PROGRAM Decl(Source,Output);

Const
  LineWidth = 70;

TYPE
  MyString = STRING[255];
  CharSet  = SET OF CHAR;

VAR
  Source     : TEXT;
  AllChars,
  Delimiters,
  Numbers,
  Letters    : CharSet;
  FileName,
  Word,
  Line,
  OutLine,
  Blanks     : MyString;
  LinePos,
  LineCount,
  InProc,
  FuncCount,
  ProcCount,
  BeginEnd,
  RecordEnd,
  TabPos     : INTEGER;
  DeclEnd,
  Ready      : BOOLEAN;


PROCEDURE UpString(VAR Source,Dest : MyString);

VAR
  I : INTEGER;

BEGIN
  Dest:=Source;
  FOR I:=1 TO Length(Dest)
  DO Dest[I]:=UpCase(Dest[I]);
END;


FUNCTION PosNonBlank(VAR Line : MyString;
                         Pos  : INTEGER) : INTEGER;

BEGIN
  WHILE (Line[Pos]=' ') AND (Pos<Length(Line))
  DO Pos:=Succ(Pos);
  IF Line[Pos]=' '
  THEN Pos:=Succ(Pos);
  PosNonBlank:=Pos;
END;


PROCEDURE NumToString(    Number : INTEGER;
                      VAR Txt    : MyString);

VAR
  Ch : CHAR;

BEGIN
  Txt:='';
  REPEAT
    Ch:=Chr(Number MOD 10+Ord('0'));
    Txt:=Concat(Ch,Txt);
    Number:=Number DIV 10;
  UNTIL Number=0;
END;


FUNCTION BeginOfWord(Var Line      : MyString;
                         Pos       : INTEGER;
                         BeginChar : CharSet) : INTEGER;

BEGIN
  WHILE (Pos<=Length(Line)) AND (NOT (Line[Pos] IN BeginChar))
  DO Pos:=Succ(Pos);
  BeginOfWord:=Pos;
END;


FUNCTION EndOfWord(Var Line    : MyString;
                       Pos     : INTEGER;
                       EndChar : CharSet) : INTEGER;

BEGIN
  REPEAT
    Pos:=Succ(Pos);
  UNTIL (Pos>Length(Line)) OR (Line[Pos] IN EndChar);
  EndOfWord:=Pos;
END;


PROCEDURE NextLine;

BEGIN
  REPEAT
    ReadLn(Source,Line);
    LineCount:=Succ(LineCount);
  UNTIL Eof(Source) OR (Line<>'');
END;


PROCEDURE StringComment;

  PROCEDURE FindEnd(EndChar : CHAR);

  BEGIN
    REPEAT
      LinePos:=Succ(LinePos);
      IF LinePos<=Length(Line)
      THEN BEGIN
             IF Line[LinePos]=EndChar
             THEN BEGIN
                    IF EndChar='*'
                    THEN BEGIN
                           IF (LinePos<Length(Line)) AND (Line[Succ(LinePos)]=')')
                           THEN BEGIN
                                  EndChar:=' ';
                                  LinePos:=Succ(LinePos);
                                END;
                         END
                    ELSE EndChar:=' ';
                  END;
           END
      ELSE IF Eof(Source)
           THEN EndChar:=' '
           ELSE BEGIN
                  NextLine;
                  LinePos:=0;
                END;
    UNTIL EndChar=' ';
    LinePos:=PosNonBlank(Line,Succ(LinePos));
    StringComment;
  END;

BEGIN
  LinePos:=PosNonBlank(Line,LinePos);
  WHILE (LinePos>Length(Line)) AND NOT Eof(Source)
  DO BEGIN
       NextLine;
       LinePos:=PosNonBlank(Line,1);
     END;
  IF LinePos<=Length(Line)
  THEN CASE Line[LinePos] OF
         '''' : FindEnd('''');
         '{'  : FindEnd('}');
         '('  : IF LinePos<Length(Line)
                THEN IF Line[Succ(LinePos)]='*'
                     THEN BEGIN
                            LinePos:=Succ(LinePos);
                            FindEnd('*');
                          END;
       END;
END;


PROCEDURE GetNextWord(VAR Word     : MyString;
                          BegChars,
                          EndChars : CharSet);

VAR
  Pos : INTEGER;

BEGIN
  Word:='';
  WHILE (Word='') AND NOT Eof(Source)
  DO BEGIN
       StringComment;
       IF LinePos<=Length(Line)
       THEN IF Line[LinePos] IN BegChars
            THEN BEGIN
                   Pos:=BeginOfWord(Line,LinePos,BegChars);
                   LinePos:=EndOfWord(Line,Pos,EndChars);
                   Word:=Copy(Line,Pos,LinePos-Pos);
                 END
            ELSE LinePos:=Succ(LinePos);
     END;
END;


PROCEDURE Out(Txt : MyString);

BEGIN
  IF Txt=''
  THEN BEGIN
         WriteLn(OutLine);
         OutLine:='';
         TabPos:=0;
       END
  ELSE IF Length(Txt)+Length(OutLine)>LineWidth
       THEN BEGIN
              WriteLn(OutLine);
              OutLine:=Copy(Blanks,1,TabPos);
            END;
  OutLine:=Concat(OutLine,Txt);
END;


PROCEDURE LineNum(Num : INTEGER);

VAR
  I    : INTEGER;
  Temp : MyString;

BEGIN
  Out('');
  IF Num>0
  THEN BEGIN
         NumToString(Num,Temp);
         WHILE Length(Temp)<5
         DO Temp:=Concat('0',Temp);
         Out(Concat(Temp,': '));
       END
  ELSE Out('       ');
  IF InProc>1
  THEN BEGIN
         FOR I:=2 TO InProc
         DO Out('.');
         Out(' ');
       END;
END;


PROCEDURE FuncProcOut;

VAR
  Temp : MyString;


  PROCEDURE ParamsOut;

  VAR
    TempWord : MyString;

  BEGIN
    Out(Temp);
    TabPos:=Length(Outline)+2;
    Temp:=' (';
    REPEAT
      GetNextWord(Word,Letters,Delimiters);
      UpString(Word,TempWord);
      IF TempWord='VAR'
      THEN Temp:=Concat(Temp,TempWord,' ')
      ELSE BEGIN
             Temp:=Concat(Temp,Word);
             GetNextWord(Word,[',',';',':','(',')'],AllChars);
             Temp:=Concat(Temp,Word);
             IF Word<>')'
             THEN Temp:=Concat(Temp,' ');
             IF Word=';'
             THEN BEGIN
                    Out(Temp);
                    Temp:='';
                  END;
           END;
    UNTIL Word=')';
    GetNextWord(Word,[':',';'],AllChars);
  END;

BEGIN
  LineNum(LineCount);
  TabPos:=0;
  Temp:=Concat(Word,' ');
  GetNextWord(Word,Letters,Delimiters);
  Temp:=Concat(Temp,Word);
  GetNextWord(Word,['(',':',';'],AllChars);
  IF Word='('
  THEN ParamsOut;
  IF Word=':'
  THEN BEGIN
         GetNextWord(Word,Letters,Delimiters);
         Temp:=Concat(Temp,': ',Word);
         GetNextWord(Word,[';'],AllChars);
       END;
  IF Word=';'
  THEN Temp:=Concat(Temp,';');
  Out(Temp);
END;


FUNCTION FileExist(Name : MyString) : BOOLEAN;

VAR
  F : TEXT;

BEGIN
  Assign(F,Name);
  {$I-}
  Reset(F);
  {$I+}
  FileExist:=IOResult=0;
  Close(F);
END;


FUNCTION ParamOK : BOOLEAN;

BEGIN
  ParamOK:=FALSE;
  IF ParamCount=0
  THEN BEGIN
         WriteLn('*** ERROR: Invalid parameter ***');
         WriteLn;
         WriteLn('Format: DECL FileName');
       END
  ELSE BEGIN
         FileName:=ParamStr(1);
         IF Pos('.',FileName)=0
         THEN FileName:=Concat(FileName,'.PAS');
         UpString(FileName,FileName);
         IF NOT FileExist(FileName)
         THEN WriteLn('*** ERROR: File "',FileName,'" not found ! ***')
         ELSE ParamOK:=TRUE;
       END;
END;


BEGIN
  IF ParamOK
  THEN BEGIN
         WriteLn;
         WriteLn('DECL v1.0     ',
                 '(C) 1988   Markus Satte, M.Ceol & PASCAL INT.');
         WriteLn;
         WriteLn('List of all procedure and function declarations of a PASCAL program');
         WriteLn;
         WriteLn ('File: ',FileName);
         WriteLn;
         AllChars:=[' '..'}'];
         Numbers:=['0'..'9'];
         Letters:=['A'..'Z','a'..'z'];
         Delimiters:=AllChars-Numbers-Letters-['_'];
         Line:='';
         OutLine:='';
         Blanks:='';
         FOR LinePos:=1 TO 200
         DO Blanks:=Concat(Blanks,' ');
         LineCount:=0;
         InProc:=0;
         BeginEnd:=0;
         RecordEnd:=0;
         FuncCount:=0;
         ProcCount:=0;
         LinePos:=1;
         Ready:=FALSE;
         Assign(Source,FileName);
         Reset(Source);
         WHILE NOT Eof(Source) AND NOT Ready
         DO BEGIN
              GetNextWord(Word,Letters,Delimiters);
              UpString(Word,Word);
              IF Word='BEGIN'
              THEN BEGIN
                     IF InProc=0
                     THEN BEGIN
                            Ready:=TRUE;
                            LineNum(LineCount);
                            Out('MAIN');
                          END
                     ELSE BeginEnd:=Succ(BeginEnd);
                   END
              ELSE IF Word='CASE'
                   THEN BEGIN
                          IF RecordEnd=0
                          THEN BeginEnd:=Succ(BeginEnd);
                        END
                   ELSE IF Word='RECORD'
                        THEN RecordEnd:=Succ(RecordEnd)
                        ELSE IF (Word='EXTERNAL') OR (Word='FORWARD')
                             THEN BEGIN
                                    LineNum(0);
                                    Out(Word);
                                    InProc:=Pred(InProc);
                                  END
                             ELSE IF Word='END'
                                  THEN IF RecordEnd>0
                                       THEN RecordEnd:=Pred(RecordEnd)
                                       ELSE BEGIN
                                              BeginEnd:=Pred(BeginEnd);
                                              IF (InProc>0) AND (BeginEnd=0)
                                              THEN InProc:=Pred(InProc)
                                            END
                                  ELSE IF (Word='PROCEDURE') OR (Word='FUNCTION')
                                       THEN BEGIN
                                              InProc:=Succ(InProc);
                                              IF Word='PROCEDURE'
                                              THEN ProcCount:=Succ(ProcCount)
                                              ELSE FuncCount:=Succ(FuncCount);
                                              FuncProcOut;
                                            END;
            END;
         Out('');
         Close(Source);
         WriteLn;
         WriteLn('Founded: ',FuncCount:3,' functions');
         WriteLn('         ',ProcCount:3,' procedures');
         WriteLn;
       END;
  WriteLn;
END.