Program Disp;

Uses Dos;

Const EnvOffset = $2C;

Type Chaine   = String [255];
     Chaine3  = String [003];
     Chaine32 = String [032];

Var
  Resultat : Chaine;
  Nombre   : Byte;

{-----------------------------------------------------------------------------}

Function GetEnv (Variable : Chaine32) : Chaine;

Var Environ,
    Offset : Word;
    Name   : Chaine32;
    Value  : Chaine;

Begin
  Environ := MemW [PrefixSeg:EnvOffset];
  OffSet := 0;
  Value := '';
  Name := '';
  While (Mem [Environ:Offset] <> 0) And (Name <> Variable)
  Do Begin
     Value := '';
     Name := '';
     While Mem [Environ:Offset] <> Ord ('=')
     Do Begin
        Name := Name + Chr (Mem[Environ:OffSet]);
        Inc (OffSet);
        End;
     Inc (Offset);
     While Mem [Environ:Offset] <> 0
     Do Begin
        Value := Value + Chr (Mem[Environ:OffSet]);
        Inc (OffSet);
        End;
     Inc (Offset);
     End;
  If Name <> Variable
     Then GetEnv := ''
     Else GetEnv := Value;
End; { GetEnv }

{-----------------------------------------------------------------------------}

Function UpStr (S : Chaine) : Chaine;
Var I : Byte;
Begin

   For I := 1 To Length (S) Do S [I] := UpCase (S [I]);
   UpStr := S;

End; { UpStr }

{-----------------------------------------------------------------------------}

Function ExeName (Name : Chaine) : Chaine;

Var I,J : Integer;

Begin

   I := Length (Name);
   J := I+1;

   While (I > 0) And (Name [I] <> '\') Do
   Begin
      If Name [I] = '.' Then J := I;
      Dec (I);
   End; { While }

   ExeName := Copy (Name, I+1, J-I-1);

End; { ExeName }

{-----------------------------------------------------------------------------}

Function Change (Quoi: Chaine; Origine, Destination: Char): Chaine;
Var
  Car : Byte;
Begin
  For Car := 1 To Length (Quoi) Do
      If Quoi[Car] = Origine
         Then Quoi[Car] := Destination;
  Change := Quoi;
End;

{-----------------------------------------------------------------------------}

Function Transforme (Quoi: Chaine) : Chaine;
Var
  HH, MI, SS,
  JJ, MM, AA,
  JDS, S100     : Word;
  HSt, MSt, SSt : Chaine;
Begin
  If (Quoi[1] <> '_') Or (Length (Quoi) <> 2)
     Then Transforme := Quoi
     Else
       Case (Quoi[2]) Of
        'T','t' : Begin
                    GetTime (HH, MI, SS, S100);
                    Str (HH:2,HSt);
                    Str (MI:2,MSt);
                    Str (SS:2,SSt);
                    Transforme := Change (HSt+':'+Mst+':'+SSt,' ','0');
                  End;
        'D'     : Begin
                    GetDate (AA, MM, JJ, JDS);
                    Str (JJ:2,HSt);
                    Str (MM:2,MSt);
                    Str (AA:2,SSt);
                    HSt := Change (HSt+'/'+Mst+'/'+SSt,' ','0');
                    Case JDS Of
                       1 : Transforme := 'Lundi '   +HSt;
                       2 : Transforme := 'Mardi '   +HSt;
                       3 : Transforme := 'Mercredi '+HSt;
                       4 : Transforme := 'Jeudi '   +HSt;
                       5 : Transforme := 'Vendredi '+HSt;
                       6 : Transforme := 'Samedi '  +HSt;
                       7 : Transforme := 'Dimanche '+HSt;
                     End {Case}
                  End;
        'd'     : Begin
                    GetDate (AA, MM, JJ, JDS);
                    Str (JJ:2,HSt);
                    Str (MM:2,MSt);
                    Str (AA:2,SSt);
                    Transforme := Change (HSt+'/'+Mst+'/'+SSt,' ','0');
                  End;
        'P'     : Begin
                    GetDir (0, HSt);
                    Transforme := HSt;
                  End;
        'e','E' : Begin
                    GetDir (0, HSt);
                    Transforme := ExeName (HSt);
                  End;
        'p'     : Transforme := '|';
        'l','L' : Transforme := '<';
        'g','G' : Transforme := '>';
        's'     : Transforme := ' ';
        'S'     : Transforme := '$';
        'q'     : Transforme := '''';
        'Q'     : Transforme := '"';
        'c'     : Transforme := '%';
        'C'     : Transforme := ',';
        'i'     : Transforme := '#';
        'I'     : Transforme := '?';
        'a'     : Transforme := '&';
        'A'     : Transforme := '@';
        'u','U' : Transforme := '+';
        'm','M' : Transforme := '*';
        'h','H' : Transforme := '^';
        '_'     : Transforme := '_';
        '-'     : Transforme := '-';
         End; {Case}
End { Transforme };

{-----------------------------------------------------------------------------}

Function TransformText (ToTransf : Chaine) : Chaine;
Var What : Chaine;
    Temp : Chaine3;
    I, J,
    K, L : Byte;
    C    : Char;
Begin
  What := '';
  J := 1;
  I := Pos ('_',ToTransf);
  While I > 0 Do
  Begin
    What := What + Copy (ToTransf, J, I-J);
    Case UpCase (ToTransf [I+1]) Of
    '^'      : Begin
                 What := What+Chr ((Ord (UpCase (ToTransf [I+2]))-64) Mod 32);
                 ToTransf [I] := #001; Inc (I);
               End;
    '#'       : Begin
                  ToTransf [I] := #001;
                  K := I+2; L := 0;
                  While     (ToTransf [K] In ['0'..'9'])
                        And (K <= Length (ToTransf))
                  Do Begin
                       L := L*10 + Ord (ToTransf [K])-48;
                       Inc (K); Inc (I);
                     End;
                  What := What + Chr (L);
                End; { Case # }
    '%'      : Begin
                  ToTransf [I]   := #001;
                  ToTransf [I+1] := #001;
                  J := Pos ('%', ToTransf);
                  While (J < I) And (J > 0)
                  Do Begin
                       ToTransf [J] := #001;
                       J := Pos ('%', ToTransf);
                     End;
                  If J > 0
                  Then Begin
                    What := What + GetEnv (UpStr (Copy (ToTransf, I+2, J-I-2)));
                    While I < J
                       Do Begin
                            ToTransf [I] := #001;
                            Inc (I);
                          End;
                    I := J-1;
                       End;
                End;
      Else     What := What + Transforme (Copy (ToTransf, I, 2));
      End; { Case }
    ToTransf [I]   := #001;
    ToTransf [I+1] := #001;
    J := I+2;
    I := Pos ('_',ToTransf);
  End; { While }
  TransformText := What + Copy (ToTransf, J, Length (ToTransf) -J+1);
End; { TransformText }

{-----------------------------------------------------------------------------}

Begin
  Resultat := '';
  Nombre := 1;
  While Nombre <= ParamCount
  Do Begin
       Resultat := Resultat+TransformText (ParamStr (Nombre))+' ';
       Inc (Nombre);
     End;
  WriteLn (Resultat);
End.
