Program Directory;

{$I+}

Uses
     Dos,
     Crt;

Const
      BDirectory = 1;
      BFile      = 2;
      BDrive     = 4;

Type
     MaxStr     = String [255];
     DirStr     = String [ 80];
     Str12      = String [ 12];
     DriveStr   = String [  2];
     PtrListDir = ^ListDir;
     ListDir    = Record
                    Name  : Str12;
                    Left  ,
                    Right ,
                    Next  ,
                    Prior : PtrListDir;
                    Line  ,
                    Row   : Byte;
                  End; {ListDir}
     Corner     = Record
                    L, R    : Byte
                  End; {Corner}
     Color      = Record
                    NormalText,
                    NormalBack,
                    HighText,
                    HighBack,
                    BoxText,
                    BoxBack,
                    BarText,
                    BarBack    : Byte
                  End; {Color}

Var
    Current_Dir       ,
    First_Dir         : DirStr;
    Current_Drive     : DriveStr;
    First_List_Dir    : PtrListDir;
    UpperLeftCorner   ,
    BottomRightCorner : Corner;
    Colors            : Color;
    BoxFrame          : Str12;
    Retour_Au_Dos     : Boolean;
    BarLine           ,
    NbOfItems         ,
    NbOfLines         ,
    Trt, I            : Byte;

{-----------------------------------------------------------------------------}

Function Iif ( Test : Boolean; Val1, Val2 : LongInt ) : LongInt;

Begin
  If Test Then Iif := Val1
          Else Iif := Val2;
End; {Iif}

{-----------------------------------------------------------------------------}

Function ExeName (Name : DirStr) : Str12;

Var I,J : Byte;

Begin

   I := Length (Name);
   J := I+1;

   While (I > 0) And (Name [I] <> '\') Do
   Begin
      If Name [I] = '.' Then J := I;
      Dec (I);
   End; { While }

   ExeName := Copy (Name, I+1, J-I-1);

End; { ExeName }

{-----------------------------------------------------------------------------}

Procedure Usage (WhoIsIt : Str12);

Begin

   WriteLn (OutPut);
   WriteLn (OutPut,'MS/Dos Directory: ',WhoIsIt,'.EXE');
   WriteLn (OutPut);
   WriteLn (OutPut,'Usage: ',WhoIsIt,' [-options]');
   WriteLn (OutPut);
   WriteLn (OutPut,'Options are: -lN1               => Line of Bar Help');
   WriteLn (OutPut,'             -bN1,N2,N3,N4[,C]  => Dimensions of the Box');
   WriteLn (OutPut,'             -s                 => clear Screen before');
   WriteLn (OutPut,'             -cN1,N2,[N3,N4]    => Colour (text,background)');
   WriteLn (OutPut);
   WriteLn (OutPut,'Available colours: - Black     (1) - Blue       (2) - Green     (3)');
   WriteLn (OutPut,'                   - Cyan      (4) - Red        (5) - Magenta   (6)');
   WriteLn (OutPut,'                   - Brown     (7) - LightGray  (8) - DarkGray  (9)');
   WriteLn (OutPut,'                   - LightBlue(10) - LightGreen(11) - LightCyan(12)');
   WriteLn (OutPut,'                   - LightRed (13) - LgtMagenta(14) - LgtYellow(15)');
   WriteLn (OutPut,'                   - White    (16)');
   WriteLn (OutPut);

End; { Usage }

{-----------------------------------------------------------------------------}

Procedure SetBox (TheBox : MaxStr);

Var Frame : Str12;
    N     : Array [1..4] Of Byte;
    I,J,V,
    X,Y   : Byte;
    Cd    : Integer;
Begin

   X := WhereX;
   Y := WhereY;
   Frame := 'Ŀ ';
   I := 2;
   TheBox [1] := #027;
   TheBox [2] := #027;

   For J := 1 To 4 Do
      If Pos (',', TheBox) > I
      Then Begin
         Val (Copy (TheBox, I+1, Pos (',', TheBox)-I-1), V, Cd);
         N [J] := V;
         I := Pos (',', TheBox);
         TheBox [I] := #027;
           End { Then }
      Else Begin
         V := 0;
         If I <= Length (TheBox)
         Then Val (Copy (TheBox, I+1, Length (TheBox)-I), V, Cd);
         N [J] := V;
         I := Length (TheBox);
           End; { Else }
      { End If }

   If I < Length (TheBox)
   Then For J := 1 To 9 Do
      If J+I <= Length (TheBox)
      Then Frame [J] := TheBox [I+J];

   BoxFrame            := Frame;
   UpperLeftCorner.L   := Iif (N [2] < N [4], N [2], N [4]);
   UpperLeftCorner.R   := Iif (N [1] < N [3], N [1], N [3]);
   BottomRightCorner.L := Iif (N [2] < N [4], N [4], N [2]);
   BottomRightCorner.R := Iif (N [1] < N [3], N [3], N [1]);

End; { SetBox }

{-----------------------------------------------------------------------------}

Procedure SetColors (TheClr : MaxStr);

Var C     : Array [1..8] Of Byte;
    I,J,V : Byte;
    Cd    : Integer;
Begin

   TheClr [1] := #027;
   TheClr [2] := #027;
   I := 2;

   For J := 1 To 8 Do
      If Pos (',', TheClr) > I
      Then Begin
         Val (Copy (TheClr, I+1, Pos (',', TheClr)-I-1), V, Cd);
         C [J] := Succ (Pred (V) Mod 16);
         I := Pos (',', TheClr);
         TheClr [I] := #027;
           End { Then }
      Else Begin
         V := 0;
         If I <= Length (TheClr)
         Then Val (Copy (TheClr, I+1, Length (TheClr)-I), V, Cd);
         C [J] := Succ (Pred (V) Mod 16);
         I := Length (TheClr);
           End; { Else }
      { End If }

   Colors.NormalText := Iif (C [1] = 0, Colors.NormalText, C [1] - 1);
   Colors.NormalBack := Iif (C [2] = 0, Colors.NormalBack, C [2] - 1);
   Colors.HighText   := Iif (C [3] = 0, Colors.NormalBack, C [3] - 1);
   Colors.HighBack   := Iif (C [4] = 0, Colors.NormalText, C [4] - 1);
   Colors.BoxText    := Iif (C [5] = 0, Colors.NormalText, C [5] - 1);
   Colors.BoxBack    := Iif (C [6] = 0, Colors.NormalBack, C [6] - 1);
   Colors.BarText    := Iif (C [7] = 0, Colors.NormalText, C [7] - 1);
   Colors.BarBack    := Iif (C [8] = 0, Colors.NormalBack, C [8] - 1);

End; { SetColors }

{-----------------------------------------------------------------------------}

Procedure SetLine (TheLin : MaxStr);

Var
    I,J,V : Byte;
    Cd    : Integer;

Begin

   TheLin [1] := #027;
   TheLin [2] := #027;
   I := 2;
   J := Pos (',', TheLin);
   Val (Copy (TheLin, I+1,
        Iif (J < I, Length (TheLin)+1, J)-I-1), V, Cd);
   BarLine := J;

End; { SetLine }

{-----------------------------------------------------------------------------}

Function MaxInt (A, B : LongInt) : LongInt;

Begin
  If A > B
     Then MaxInt := A
     Else MaxInt := B;
End; { MaxInt }

{-----------------------------------------------------------------------------}

Procedure InitParam (Param : MaxStr);

Begin

   If Param [1] <> '-'
   Then WriteLn (OutPut,'Parameter Error, ''-'' expected: "',Param,'"')
   Else
      Case UpCase (Param [2]) Of
           'S' : Begin
                    TextColor      (Colors.NormalText);
                    TextBackGround (Colors.NormalBack);
                    ClrScr;
                 End; { Case 'S' }
           'C' : SetColors (Param);
           'B' : SetBox (Param);
           'L' : SetLine (Param);
      Else WriteLn (OutPut,'Parameter not recognised: "',Param[2],'" (ignored)');
      End; { Case }
   { End If }

End; { initParam }

{-----------------------------------------------------------------------------}

Function Space (Leng : Byte) : MaxStr;

Var
    TheSpaces : MaxStr;

Begin
  TheSpaces [0] := Chr (Leng);
  While Leng > 0
    Do
      Begin
        TheSpaces [Leng] := ' ';
        Leng             := Pred (Leng);
      End;
  Space := TheSpaces;
End; { Space }

{-----------------------------------------------------------------------------}

Procedure Box (L,U,R,D : Byte; F : Str12);

Var I,J : Byte;

Begin

   If L = R Then For I := 1 To 9 Do F [I] := F [8];
   If U = D Then For I := 1 To 9 Do F [I] := F [2];
   GotoXY (L, U); Write (F [1]);

   If L < R-1
   Then Begin
      For I := L+1 To R-1 Do Write (F [2]);
      Write (F [3]);
        End; { For If }

   If U < D-1
   Then
      For I := U+1 To D-1 Do
      Begin
         GotoXY (L, I); Write (F [8]);
         If L < R-1
         Then Begin
            For J := L+1 To R-1 Do Write (F [9]);
            Write (F [4]);
               End; { For If }
      End; { For If }

   GotoXY (L, D); Write (F [7]);
   If L < R-1
   Then Begin
      For I := L+1 To R-1 Do Write (F [6]);
      Write (F [5]);
        End; { For If }

End; {Box}

{-----------------------------------------------------------------------------}

Procedure Charge_Repert (  CurDir   : DirStr;
                         Var
                           FirstDir : PtrListDir;
                           TheTrt   : Byte
                        );

Var
  SortDir,
  OldDir,
  TheDir   : PtrListDir;
  DirInf   : SearchRec;

     Procedure Sort_It;
       Begin
         New (TheDir);
         TheDir^.Name  := DirInf.Name;
         TheDir^.Prior := Nil;
         TheDir^.Next  := Nil;
         SortDir       := FirstDir;

         While     ( SortDir^.Next <> Nil )
               And ( SortDir^.Name < TheDir^.Name )
            Do SortDir := SortDir^.Next;

         If OldDir = Nil
            Then FirstDir       := TheDir;

         If TheDir^.Name < SortDir^.Name
            Then
              Begin
                If SortDir^.Prior = Nil
                   Then FirstDir             := TheDir
                   Else SortDir^.Prior^.Next := TheDir;
                TheDir^.Prior                := SortDir^.Prior;
                TheDir^.Next                 := SortDir;
                SortDir^.Prior               := TheDir;
              End
            Else
              Begin
                TheDir^.Prior          := SortDir;
                SortDir^.Next          := TheDir;
              End;

       End; {Sort_It}


Begin
  FindFirst (CurDir+'\*.*', 16, DirInf);
  FirstDir := Nil;

  While DosError = 0 Do
    Begin
      If    (     ( DirInf.Attr = $10  { Directory } )
              And ( TheTrt      = BDirectory )       )
         Or (     ( DirInf.Attr In [$01,$20]  { File } )
              And ( TheTrt      = BFile )              )
         Then
           If FirstDir <> Nil
              Then Sort_It
              Else
                Begin
                  New (FirstDir);
                  FirstDir^.Name  := DirInf.Name;
                  FirstDir^.Prior := Nil;
                  FirstDir^.Next  := Nil;
                End;
      FindNext (DirInf);
    End; {While DosError ... }

  If FirstDir = Nil
     Then
       Begin
         New (FirstDir);
         If TheTrt = BFile
            Then FirstDir^.Name  := ' {No File}'
            Else FirstDir^.Name  := '  {No Dir}';
         FirstDir^.Prior         := Nil;
         FirstDir^.Next          := Nil;
       End;

End; {Charge_Repert}

{-----------------------------------------------------------------------------}

Procedure Charge_Lecteur ( Var FirstDrive : PtrListDir);

Var
  OldDrive,
  TheDrive  : PtrListDir;
  TheDrvNme : Byte;
  SizeOfDrv : LongInt;
  LastDrv   : Str12;

Begin
  OldDrive   := Nil;
  FirstDrive := Nil;
{  LastDrv    := GetEnv ('LASTDRIVE');}
  LastDrv    := 'Z';

  For TheDrvNme := 1 To Ord (LastDrv [1]) - 64 Do
  Begin
    New (TheDrive);
    If OldDrive <> Nil Then OldDrive^.Next := TheDrive;
    TheDrive^.Name  := Chr (TheDrvNme + 64) + ':';
    TheDrive^.Prior := OldDrive;
    If OldDrive = Nil Then FirstDrive := TheDrive;
    TheDrive^.Next  := Nil;
    OldDrive        := TheDrive;
  End;
End; {Charge_Lecteur}

{-----------------------------------------------------------------------------}

Procedure Init_All (TheTrt : Byte);

Begin
  GetDir (0, Current_Dir);
  Current_Drive := Copy (Current_Dir, 1, 2);

  If Current_Dir [Length (Current_Dir)] = '\'
     Then Current_Dir [0] := Pred (Current_Dir [0]);

  If BottomRightCorner.L - UpperLeftCorner.L < 3
     Then If BottomRightCorner.L > 22
             Then UpperLeftCorner.L   := UpperLeftCorner.L   - 2
             Else BottomRightCorner.L := BottomRightCorner.L + 2;

  BottomRightCorner.R :=   UpperLeftCorner.R
                         + ( ( BottomRightCorner.R - UpperLeftCorner.R - 4 )
                               Div 14 ) * 14 + 16;

  NbOfLines := ( BottomRightCorner.L - UpperLeftCorner.L - 1 );
  NbOfItems :=   ( ( BottomRightCorner.R - UpperLeftCorner.R - 4 ) Div 14 + 1 )
               * NbOfLines;

  If TheTrt <> BDrive
     Then Charge_Repert (Current_Dir, First_List_Dir, TheTrt)
     Else Charge_Lecteur (First_List_Dir);

End; {Init_All}

{-----------------------------------------------------------------------------}

Function Affich_Repert (FirstDir : PtrListDir) : PtrListDir;

Var
  Line,
  Row,
  MaxRow,
  CurRow,
  Leng    : Byte;
  TheDir  ,
  LastRow ,
  LastDir : PtrListDir;

Begin

  TextColor      (Colors.BoxText);
  TextBackGround (Colors.NormalBack);
  Box (UpperLeftCorner.R,   UpperLeftCorner.L,
       BottomRightCorner.R, BottomRightCorner.L,
       BoxFrame);
  TextColor      (Colors.NormalText);

  TheDir  := FirstDir;
  LastDir := TheDir;
  LastRow := Nil;
  Line    := Succ (UpperLeftCorner.L);
  Row     := UpperLeftCorner.R + 2;
  Leng    := BottomRightCorner.R - UpperLeftCorner.R - 2;
  CurRow  := 1;
  MaxRow  := Leng Div 14;

  GotoXY (Pred (Row), Pred (Line));
  Write (' ', Copy (Current_Dir, 1, 2),
              Copy (Current_Dir + Space (Leng),
                    MaxInt (Ord (Current_Dir [0]) - Leng + 4, 3),
                    Leng - 3), ' ');

  If TheDir^.Prior <> Nil
    Then
      Begin
        GotoXY (BottomRightCorner.R, Line);
        Write (#24);    {Flche vers le haut}
      End;

  While ( TheDir <> Nil ) And ( CurRow <= MaxRow ) Do
  Begin
    GotoXY (Row, Line);
    Write (Copy (TheDir^.Name + Space (12), 1, 12));
    TheDir^.Line := Line;
    TheDir^.Row  := Row;

    If LastRow <> Nil
       Then
         Begin
           TheDir^.Left   := LastRow;
           LastRow^.Right := TheDir;
           LastRow        := LastRow^.Next;
         End
       Else TheDir^.Left := Nil;

    TheDir^.Right := Nil;
    Line          := Succ (Line);
    LastDir       := TheDir;
    TheDir        := TheDir^.Next;

    If Line >= BottomRightCorner.L
       Then
         Begin
           Line   := Succ (UpperLeftCorner.L);
           CurRow := Succ (CurRow);
           Row    := Row + 14;
           If LastRow = Nil Then LastRow := FirstDir;
         End;

  End; {While (TheDir ... ) Do}

  If LastDir^.Next <> Nil
     Then
       Begin
         GotoXY (BottomRightCorner.R, Pred (BottomRightCorner.L));
         Write (#25);  {flche vers le bas}
       End;

  Affich_Repert := LastDir;

End; {Affich_Repert}

{-----------------------------------------------------------------------------}

Function Traite_Repert (TrtType : Byte) : Byte;

Var
  TopDir,
  BottomDir,
  HighDir    : PtrListDir;
  TheKey     : Char;
  I,
  PredLine   : Byte;
  FcKey      : Boolean;

         Procedure Left;
           Begin
             If HighDir^.Left <> Nil
               Then HighDir := HighDir^.Left
               Else
                 Begin
                   PredLine := HighDir^.Line;
                   I        := 1;
                   While     ( I <= NbOfLines )
                         And ( TopDir^.Prior <> Nil )
                   Do Begin
                        TopDir    := TopDir^.Prior;
                        HighDir   := HighDir^.Prior;
                        I         := Succ (I);
                      End;
                   BottomDir := Affich_Repert (TopDir);
                   If HighDir^.Line <> PredLine Then HighDir := BottomDir;
                 End;
           End; {Left}

         Procedure Right;
           Begin
             If HighDir^.Right <> Nil
               Then HighDir := HighDir^.Right
               Else
                 Begin
                   PredLine := HighDir^.Line;
                   I        := 1;
                   While     ( I <= NbOfLines )
                         And ( BottomDir^.Next <> Nil )
                   Do Begin
                        TopDir    := TopDir^.Next;
                        HighDir   := HighDir^.Next;
                        BottomDir := BottomDir^.Next;
                        I         := Succ (I);
                      End;
                   BottomDir := Affich_Repert (TopDir);
                   If HighDir^.Line <> PredLine Then HighDir := BottomDir;
                 End;
           End; {Right}

         Procedure Down;
           Begin
             If HighDir^.Next <> Nil
                Then
                  Begin
                    HighDir := HighDir^.Next;
                    If     (HighDir^.Prior = BottomDir)
                       And (HighDir^.Prior <> TopDir)
                       Then
                         Begin
                           BottomDir := Affich_Repert (TopDir^.Next);
                           TopDir    := TopDir^.Next;
                         End;
                  End;
           End; {Down}

         Procedure Up;
           Begin
             If HighDir^.Prior <> Nil
                Then
                  Begin
                    HighDir := HighDir^.Prior;
                    If HighDir^.Next = TopDir
                       Then
                         Begin
                           BottomDir := Affich_Repert (HighDir);
                           TopDir    := HighDir;
                         End;
                  End;
           End; {Up}

         Procedure PgDn;
           Begin
             If HighDir = BottomDir
                Then
                  Begin
                    I := 1;
                    While     ( I <= NbOfItems )
                          And ( BottomDir^.Next <> Nil )
                      Do Begin
                           BottomDir := BottomDir^.Next;
                           TopDir    := TopDir^.Next;
                           I         := Succ (I);
                         End;
                    BottomDir := Affich_Repert (TopDir);
                  End;
             HighDir  := BottomDir;
           End; {PgDn}

         Procedure PgUp;
           Begin
             If HighDir = TopDir
                Then
                  Begin
                    I := 1;
                    While     ( I <= NbOfItems )
                          And ( TopDir^.Prior <> Nil )
                      Do Begin
                           TopDir := TopDir^.Prior;
                           I      := Succ (I);
                         End;
                    BottomDir := Affich_Repert (TopDir);
                  End;
             HighDir  := TopDir;
           End; {PgUp}

         Procedure Home;
           Begin
             HighDir   := First_List_Dir;
             TopDir    := HighDir;
             BottomDir := Affich_Repert (HighDir);
           End; {Home}

         Procedure EndK;
           Begin
             While BottomDir^.Next <> Nil
               Do Begin
                    TopDir    := TopDir^.Next;
                    BottomDir := BottomDir^.Next;
                  End;
             HighDir   := BottomDir;
             BottomDir := Affich_Repert (TopDir);
           End; {EndK}

         Procedure EnterDirectory;
           Begin
             If     ( HighDir^.Name <> '.'          )
                And ( HighDir^.Name <> '  {No Dir}' )
               Then
                 If HighDir^.Name = '..'
                   Then
                     Begin
                       I := Length (Current_Dir);
                       While     (Current_Dir [I] <> '\')
                             And (I > 1) Do I := Pred (I);
                       If I > 3
                          Then Current_Dir [0] := Chr (Pred (I))
                          Else Current_Dir [0] := #3;
                     End
                   Else Current_Dir := Current_Dir + '\' + HighDir^.Name;
             ChDir (Current_Dir);
           End; {EnterDirectory}

         Procedure EnterDrive;
         Var CurDir : DirStr;
           Begin
             GetDir (Ord (HighDir^.Name[1]) - 64, CurDir);
             If IoResult <> 0 Then CurDir := Current_Dir;
             ChDir (CurDir);
             If IoResult = 0 Then Current_Dir := CurDir;
             ChDir (Current_Dir);
             TrtType := BDirectory;
           End; {EnterDrive}

         Procedure ExecuteFile;
           Begin
             Exec (Current_Dir+'\'+HighDir^.Name,' ');
             write(doserror);
             Repeat Until Keypressed;
             Repeat
               TheKey := ReadKey;
             Until Not Keypressed;
             TheKey := #255;
           End; {ExecuteFile}

Begin
  HighDir   := First_List_Dir;
  TopDir    := HighDir;
  TheKey    := #255;
  BottomDir := Affich_Repert (HighDir);

  TextColor      (Colors.BarText);
  TextBackGround (Colors.BarBack);
  GotoXY (2,25);
  Write (Space (78));
  GotoXY (2,25);

  Case TrtType Of
  BDirectory :
      Write ('Esc - Quitte  F2 - change d''Unit   F3 - Voir fichiers  F10 - Rpertoire ..');
  BFile      :
      Write ('Esc - Quitte  F2 - Visualise         F3 - Rpertoire');
  BDrive     :
      Write ('Esc - Quitte  F2 - Rpertoire');
  End; {Case}

  TextColor      (Colors.HighText);
  TextBackGround (Colors.HighBack);
  GotoXY (HighDir^.Row, HighDir^.Line);
  Write  (Copy (HighDir^.Name + Space(12), 1, 12));
  GotoXY (HighDir^.Row, HighDir^.Line);

  Repeat

    Repeat
      If KeyPressed
        Then
          Begin
            TheKey := ReadKey;
            FcKey  := False;
            If TheKey = #0
              Then Begin
                     TheKey := ReadKey;
                     FcKey  := True;
                   End;
          End
        Else
          TheKey := #255;

      If Not FcKey
        Then If Not (TheKey In [' ',#13,#27])
                Then TheKey := #255;
    Until TheKey <> #255;

    If TheKey <> #255
      Then
        Begin
          GotoXY (HighDir^.Row, HighDir^.Line);
          TextColor      (Colors.NormalText);
          TextBackGround (Colors.NormalBack);
          Write (Copy (HighDir^.Name + Space(12), 1, 12));
        End;

    Case TheKey Of
         #75 {Left}     : Left;
         #77 {Right}    : Right;
         ' ',#80 {Down} : Down;
         #72 {Up}       : Up;
         #81 {PgDn}     : PgDn;
         #73 {PgUp}     : PgUp;
         #71 {Home}     : Home;
         #79 {End}      : EndK;
         #13 {Enter}    : If TrtType = BDirectory
                             Then
                               EnterDirectory
                             Else
                               If TrtType = BDrive
                                  Then EnterDrive
                                  Else ExecuteFile;
         #60 {F2}       : If TrtType = BDirectory
                             Then
                               TrtType := BDrive
                              Else
                               If TrtType = BDrive
                                  Then
                                    TrtType := BDirectory;
         #61 {F3}       : If TrtType = BDirectory
                             Then
                               TrtType := BFile
                              Else
                               If TrtType = BFile
                                  Then
                                    TrtType := BDirectory;
         #68 {F10}      : If TrtType = BDirectory
                             Then Begin
                               HighDir^.Name := '..';
                               EnterDirectory;
                               TheKey := #13;
                                  End;
         #27 {Esc}      : Retour_Au_Dos := True;
    End; {Case}

    If TheKey <> #255
      Then
        Begin
          GotoXY (HighDir^.Row, HighDir^.Line);
          TextColor      (Colors.HighText);
          TextBackGround (Colors.HighBack);
          Write  (Copy (HighDir^.Name + Space(12), 1, 12));
          GotoXY (HighDir^.Row, HighDir^.Line);
        End;

  Until TheKey In [#13, #27, #60, #61];

  Traite_Repert := TrtType;

End; {Traite_Repert}


{-----------------------------------------------------------------------------}


Begin {Traitement Principal}
  Retour_Au_Dos       := False;
  Trt                 := BDirectory;
  With Colors Do
    Begin
      NormalText      := 14; {LightYellow}
      NormalBack      :=  1; {Blue}
      HighText        :=  1;
      HighBack        :=  3;
      BoxText         := 14;
      BoxBack         :=  1;
      BarText         := 14;
      BarBack         :=  1;
    End;
  BottomRightCorner.L := 17;
  BottomRightCorner.R := 48;
  UpperLeftCorner.L   :=  7;
  UpperLeftCorner.R   := 32;
  BoxFrame            := 'Ŀ ';

  If ( ParamCount = 1 ) And (    ( ParamStr (1) = 'H' )
                              Or ( ParamStr (1) = 'h' ) )
     Then
       Begin
         Usage (ExeName (ParamStr (0)));
         Halt (0);
       End;

  If ParamCount > 0
     Then For I := 1 To ParamCount
              Do InitParam (ParamStr (I));

  Repeat
    Init_All (Trt);
    Trt := Traite_Repert (Trt);
  Until Retour_Au_Dos;
end. {Traitement principal}
