Program GenMenu (Input, OutPut);

Const MaxMenus         =   20;
      MaxDeep          = #007;
      MaxStringLength  =  255;

      _1STPX  : Integer =  2;   _1STPX_  = 'HDIFF1';
      _12STPX : Integer = -7;   _12STPX_ = 'HDIFF12';
      _2STPX  : Integer =  5;   _2STPX_  = 'HDIFF2';
      _12STPY : Integer =  1;   _12STPY_ = 'VDIFF12';
      _2STPY  : Integer = -1;   _2STPY_  = 'VDIFF2';

Type StrMax  = String [MaxStringLength];
     Str80   = String [80];
     Str8    = String [8];
     PStrMax = ^StrMax;
     MenuLine=Record
                Text : PStrMax;
                Exet : PStrMax;
                Comm : PStrMax;
              End; { Record }
     OneMenu = Array  [1..MaxMenus] Of MenuLine;
     POneMenu=^OneMenu;

Var ChIn    : StrMax;
    TitI,
    LrgTmp  : Byte;
    Titre   : Array [1..5] Of Str80;
    Format  : Str8;
    SpacesAtBeginning : Set Of Char;

{-----------------------------------------------------------------------------}

Function Iif (B : Boolean; T, F: Integer) : Integer;
Begin
  If B Then Iif := T Else Iif := F;
End; { Iif }

{-----------------------------------------------------------------------------}

Function UpStr (S : StrMax) : StrMax;
Var I : Byte;
Begin

   For I := 1 To Length (S) Do S [I] := UpCase (S [I]);
   UpStr := S;

End; { UpStr }

{-----------------------------------------------------------------------------}

Function Replicate (C : Char; X : Byte) : StrMax;

Var S : StrMax;

Begin

   S [0] := Chr (X);

   While X > 0 Do Begin S [X] := C; Dec (X); End;

   Replicate := S;

End; { Replicate }

{-----------------------------------------------------------------------------}

Function Ordre (N : Byte) : Char;
Begin
  If N < 10 Then Ordre := Chr (48+N)
            Else Ordre := Chr (55+N);
End; { Ordre }

{-----------------------------------------------------------------------------}

Procedure ReadNewEntry (Var EntryToGet : StrMax);
Var I, J  : Byte;
    InGet : StrMax;
Begin

  ReadLn (Input, InGet);
  I := 1;
  EntryToGet := '';

  While (I <= Length (InGet)) And (InGet [I] In SpacesAtBeginning) Do Inc (I);

  While (I <= Length (InGet))
  Do Begin
     EntryToGet := EntryToGet+InGet [I]; Inc (I);
     End;

End;

{-----------------------------------------------------------------------------}

Procedure NewOption (Var M : POneMenu);
Var I : Byte;
Begin
  New (M);
  For I := 1 To MaxMenus
  Do Begin
       M^[I].Text := Nil;
       M^[I].Exet := Nil;
       M^[I].Comm := Nil;
     End;
End; { NewOption }

{-----------------------------------------------------------------------------}

Procedure DisposeOption (Var M : POneMenu);
Var I : Byte;
Begin
  For I := 1 To MaxMenus
  Do Begin
       If M^[I].Text <> Nil Then Dispose (M^[I].Text);
       If M^[I].Exet <> Nil Then Dispose (M^[I].Exet);
       If M^[I].Comm <> Nil Then Dispose (M^[I].Comm);
     End;
  Dispose (M);
End; { NewOption }

{-----------------------------------------------------------------------------}

Procedure GetMenuCarr;
Var MenuCarr : Text;
    Carract  : Str8;
    I, J     : Integer;
Label EndCase;
Begin
  Assign (MenuCarr, Format+'.DMG');
  Reset (MenuCarr);
  While Not Eof (MenuCarr)
  Do Begin
     ReadLn (MenuCarr, ChIn);
     Carract := UpStr (Copy (ChIn, 1, Pos ('=', ChIn)-1));
     If Carract = _1STPX_
     Then Begin
          Val (Copy (ChIn, Pos ('=', ChIn)+1, Length (ChIn)), I, J);
          _1STPX := I;
          GoTo EndCase;
          End;
     If Carract = _12STPX_
     Then Begin
          Val (Copy (ChIn, Pos ('=', ChIn)+1, Length (ChIn)), I, J);
          _12STPX := I;
          GoTo EndCase;
          End;
     If Carract = _2STPX_
     Then Begin
          Val (Copy (ChIn, Pos ('=', ChIn)+1, Length (ChIn)), I, J);
          _2STPX := I;
          GoTo EndCase;
          End;
     If Carract = _12STPY_
     Then Begin
          Val (Copy (ChIn, Pos ('=', ChIn)+1, Length (ChIn)), I, J);
          _12STPY := I;
          GoTo EndCase;
          End;
     If Carract = _2STPY_
     Then Begin
          Val (Copy (ChIn, Pos ('=', ChIn)+1, Length (ChIn)), I, J);
          _2STPY := I;
          GoTo EndCase;
          End;
EndCase:
     End; {While}
End; { GetMenuCarr }

{-----------------------------------------------------------------------------}

Function FirstLetter (Var M : OneMenu; N : Byte) : Char;
Var I, J : Byte;
    C    : Char;
    SC   : Set Of Char;
Begin
  C := #000;
  SC := [ ];
  For I := 1 To N
  Do Begin
     J := 1;
     While     (J <= Length (M[I].Text^))
           And (M[I].Text^[J] In SC)
           And Not (M[I].Text^[J] In ['A'..'Z', '0'..'9'])
     Do Inc (J);
     If     (J <= Length (M[I].Text^))
        And Not (M[I].Text^[J] In SC)
        And (M[I].Text^[J] In ['A'..'Z', '0'..'9'])
        Then C := M[I].Text^[J]
        Else Begin
               J := 1;
               While     (J <= Length (M[I].Text^))
                     And (M[I].Text^[J] In SC)
               Do Inc (J);
               If (J <= Length (M[I].Text^)) And Not (M[I].Text^[J] In SC)
               Then C := M[I].Text^[J];
             End;
     If C <> #000 Then SC := SC + [ C ];
     End;
  If C <> #000 Then FirstLetter := C Else FirstLetter := M[N].Text^[1];
End; { FirstLetter }

{-----------------------------------------------------------------------------}

Function FirstPosition (Var M : OneMenu; N : Byte) : Byte;
Var I, J : Byte;
    C    : Char;
    SC   : Set Of Char;
Begin
  C := #000;
  SC := [ ];
  For I := 1 To N
  Do Begin
     J := 1;
     While     (J <= Length (M[I].Text^))
           And (M[I].Text^[J] In SC)
           And Not (M[I].Text^[J] In ['A'..'Z', '0'..'9'])
     Do Inc (J);
     If     (J <= Length (M[I].Text^))
        And Not (M[I].Text^[J] In SC)
        And (M[I].Text^[J] In ['A'..'Z', '0'..'9'])
        Then C := M[I].Text^[J]
        Else Begin
               J := 1;
               While     (J <= Length (M[I].Text^))
                     And (M[I].Text^[J] In SC)
               Do Inc (J);
               If (J <= Length (M[I].Text^)) And Not (M[I].Text^[J] In SC)
               Then C := M[I].Text^[J];
             End;
     If C <> #000 Then SC := SC + [ C ];
     End;
  If C <> #000 Then FirstPosition := J Else FirstPosition := 0;
End; { FirstPosition }

{-----------------------------------------------------------------------------}

Procedure InsertMenu (C, L : Byte; O : Str8);
Var I, N, X : Byte;
    M       : POneMenu;
    Large   : Byte;
    Comments: Boolean;

  Procedure AnalyseInput;

    Procedure GetTheText;
    Begin
       New (M^[N].Text);
       M^[N].Text^ := ChIn;
    End; {GetTheText}

    Procedure GetACommand;
    Begin
       If (Pos (',', ChIn) > 0) And (M^[N].Text^[1] <> '-')
       Then Begin
            M^[N].Text^ := Copy (ChIn, 1, Pos (',', ChIn)-1);
            New (M^[N].Exet);
            M^[N].Exet^ := Copy (ChIn, Pos (',', ChIn)+1, Length (ChIn));
            End;
    End; {GetACommand}

    Procedure GetAComment;
    Begin
       If (Pos ('&', ChIn) > 0) And (M^[N].Text^[1] <> '-')
       Then Begin
            If Pos (',', ChIn) <= 0
            Then M^[N].Text^ := Copy (ChIn, 1,
                                            Pos ('&', ChIn)-1)
            Else M^[N].Exet^ := Copy (ChIn, Pos (',', ChIn)+1,
                                            Pos ('&', ChIn)-1);
            New (M^[N].Comm);
            M^[N].Comm^ := Copy (ChIn, Pos ('&', ChIn)+1, Length (ChIn));
            Comments := True;
            End;
    End; {GetAComment}

  Begin
    While (ChIn [1] <> '*') And Not Eof (InPut)
    Do Begin
       Inc (N);

       GetTheText;
       GetACommand;
       GetAComment;

       X := Iif (O [0]=#000, X+_1STPX, 0)+Length (M^[N].Text^);

       If (M^[N].Exet = Nil) And (O[0] < MaxDeep) And (ChIn [1] <> '-')
       Then InsertMenu (Iif (O [0]=#000, X+_12STPX, C+X+_2STPX),
                        Iif (O [0]=#000, _12STPY, L+N+_2STPY),
                        O+Ordre (N));

       ReadNewEntry (ChIn);
       End;

  End; { AnalyseInput }

  Procedure WriteCompleteOption;
  Begin
    If M^[I].Text^[1] <> '-'
    Then If O [0] = #000
         Then WriteLn (OutPut,
                '+',X+1,                                ',',
                1,                                      ',',
                ' '+M^[I].Text^+' ',                    ',',
                FirstLetter (M^, I),                    ',',
                FirstPosition (M^, I),                  ',0,',
                O+Ordre (I),                            ',0')
         Else WriteLn (OutPut,
                '+',C,                                  ',',
                I+1+L,                                  ',',
                Copy ('  '+M^[I].Text^+' '+
                     Chr (Iif (M^[I].Exet = Nil, 62, 32))+
                     Replicate (' ',Large), 1, Large+4),',',
                FirstLetter (M^, I),                    ',',
                FirstPosition (M^, I)+1,                ',0,',
                O+Ordre (I),                            ',0');
  End; { WriteCompleteOption }

  Procedure WriteOptionComments;
  Begin
    If M^[I].Comm <> Nil
       Then WriteLn (OutPut, Copy ('-?'+M^[I].Comm^+' $',
                                   1, MaxStringLength))
       Else WriteLn (OutPut, '-? $');
  End; { WriteOptionComments }

  Procedure WriteOptionCommand;
  Begin
    If M^[I].Exet <> Nil
    Then Begin
         WriteLn (OutPut);
         WriteLn (OutPut, '-p', O+Ordre (I));
         WriteLn (OutPut, '-x_s,',M^[I].Exet^,',x');
         End;
  End; { WriteOptionCommand }

Begin

  ReadNewEntry (ChIn);

  X        := 1;
  Large    := 1;
  N        := 0;
  Comments := False;

  NewOption (M);

  AnalyseInput;
  WriteLn (OutPut);

  If O [0] = #000
  Then WriteLn (OutPut, '-p********')
  Else WriteLn (OutPut, '-p'+O);

  X := 2;

  For I := 1 To N
  Do Begin
     LrgTmp := Length (M^[I].Text^);
     If (Large < LrgTmp) And (M^[I].Text^[1] <> '-')
        Then Large := LrgTmp;
     End;

  If C+Large+4 > 80 then C := 80-Large-4;
  If N+2+L > 23 Then L := 23-2-N;

  For I := 1 To N
  Do Begin
     LrgTmp := Length (M^[I].Text^);
     WriteCompleteOption;
     X := X+LrgTmp+2;
     If Comments Then WriteOptionComments;
     End;

  If O [0] <> #000
  Then WriteLn (OutPut, '-b',C-1,',',L+1,',',C+Large+4,',',I+2+L);

  For I := 1 To N
  Do If M^[I].Text^[1] = '-'
     Then If Length (M^[I].Text^) > 1
          Then WriteLn (OutPut, M^[I].Text^)
          Else If O [0] <> #000
               Then WriteLn (OutPut, '-b',C,',',L+I+1,',',C+Large+3,',',L+I+1);

  If O [0] = #001
  Then WriteLn (OutPut, '-z********,1,1,80,25')
  Else WriteLn (OutPut, '-z'+Copy (O, 1, Length (O)-1)+',1,1,80,25');

  For I := 1 To N Do WriteOptionCommand;

  DisposeOption (M);

End; { InsertMenu }

{-----------------------------------------------------------------------------}

Begin

  SpacesAtBeginning := [#032, #009];
  Format            := 'ORAP';
  If ParamCount > 1 Then Format := UpStr (ParamStr (1));
  GetMenuCarr;

  WriteLn (OutPut, '-y00000000');
  WriteLn (OutPut);
  WriteLn (OutPut, '-pZZZZZZZZ');
  WriteLn (OutPut, '_#000');
  WriteLn (OutPut, '-u3');
  WriteLn (OutPut, '-m_^M');
  WriteLn (OutPut, '-d255');
  WriteLn (OutPut);

  TitI := 1;
  ReadNewEntry (ChIn);
  While (ChIn <> '*') And Not Eof (InPut) And (TitI < 5)
  Do Begin
       Titre [TitI] := Copy (ChIn, 1, 80);
       Inc (TitI);
       ReadNewEntry (ChIn);
     End;

  If Eof (InPut) Then Halt (255);
  ReadNewEntry (ChIn);

  InsertMenu (3, 0, '');

  WriteLn (OutPut, '-p00000000');
  WriteLn (OutPut, '-s');
  WriteLn (OutPut, '-c15,2');
  WriteLn (OutPut, '-e');
  WriteLn (OutPut, '-c1,8');
  WriteLn (OutPut, '-b1,24,80,24,         $');
  WriteLn (OutPut, '-c15,2,1,8,16,2,9,8,15,7,13,2,1,8');
  WriteLn (OutPut, '-m_^M');
  WriteLn (OutPut, '-b1,2,80,2');
  WriteLn (OutPut, '-g1,1,1,24');
  WriteLn (OutPut, '+',39-Length (Titre [1]) Div 2,',2, ',
                   Titre [1],' ,,0,0,********');

  Repeat
    ReadNewEntry (ChIn);
    WriteLn (OutPut, ChIn);
  Until Eof (InPut);

End.
