const
  MaxWorldsGlb=4;
  MaxWindowsGlb=16;
  MaxPiesGlb=10;
  MaxPlotGlb=100;
  StringSizeGlb=80;
  HeaderSizeGlb=10;
  RamScreenGlb:boolean=true;
  CharFile:string[StringSizeGlb]='4x6.fon';
  MaxProcsGlb=26;
  MaxErrsGlb=7;

type
  wrkstring=string[StringSizeGlb];
  WorldType=record
              x1,y1,x2,y2:real;
            end;
  WindowType=record
               x1,y1,x2,y2:integer;
               header:wrkstring;
               drawn,top:boolean;
               size:integer;
             end;
  worlds=array [1..MaxWorldsGlb] of WorldType;
  windows=array [1..MaxWindowsGlb] of WindowType;
  PlotArray=array [1..MaxPlotGlb,1..2] of real;
  character=array [1..3] of byte;
  CharArray=array [32..126] of character;
  PieType=record
            area:real;
            text:wrkstring;
          end;
  PieArray=array [1..MaxPiesGlb] of PieType;
  BackgroundArray=array [0..7] of byte;
  LineStyleArray=array [0..7] of boolean;

var
  X1WldGlb,X2WldGlb,Y1WldGlb,Y2WldGlb,AxGlb,AyGlb,BxGlb,ByGlb:real;
  X1RefGlb,X2RefGlb,Y1RefGlb,Y2RefGlb:integer;
  LinestyleGlb,MaxWorldGlb,MaxWindowGlb,WindowNdxGlb:integer;
  X1Glb,X2Glb,Y1Glb,Y2Glb:integer;
  XTextGlb,YTextGlb,VStepGlb:integer;
  PieGlb,DirectModeGlb,ClippingGlb,AxisGlb,HatchGlb:boolean;
  MessageGlb,BrkGlb,HeaderGlb,TopGlb,GrafModeGlb:boolean;
  CntGlb,ColorGlb:byte;
  ErrCodeGlb:byte;
  LineStyleArrayGlb:LineStyleArray;
  ErrorProc:array [0..MaxProcsGlb] of ^WrkString;
  ErrorCode:array [0..MaxErrsGlb] of ^WrkString;
  PcGlb:string[40];
  AspectGlb:real;
  GrafBase:integer;
  world:worlds;
  window:windows;
  CharSet:CharArray;

const
  XMaxGlb=79;
  XScreenMaxGlb=639;
  YMaxGlb=199;
  IVStepGlb=2;
  ScreenSizeGlb=8191;
  HardwareGrafBase=$B800;
  FontLoaded:boolean=false;
  MinForeground=1;
  MaxForeground=15;
  MinBackground=0;
  MaxBackground=0;
  AspectFactor=0.44;
  SaveStateGlb:integer=10;
  RamScreenInCard:boolean=false;

type
  ScreenType=array [0..ScreenSizeGlb] of integer;
  ScreenPointer=^ScreenType;
  WindowStackRecord=record
                      W:WindowType;
                      Contents:ScreenPointer;
                    end;
  stacks=array [1..MaxWindowsGlb] of WindowStackRecord;

var
  ScreenGlb:ScreenPointer;
  ConOutPtrSave:integer;
  Stack:Stacks;

function HardwarePresent: boolean; begin end;
function BaseAddress(Y: integer): integer; begin end;
procedure LeaveGraphic; begin end;
procedure DC(C: byte); begin end;
procedure DisplayChar(C: byte); begin end;
procedure SetForegroundColor(Color: Integer); begin end;
procedure SetBackgroundColor(Color: Integer); begin end;
procedure ClearScreen; begin end;
procedure EnterGraphic; begin end;
procedure DP(X,Y: integer); begin end;
function PD(x,y:integer):boolean; begin end;
procedure SetBackground8(Background:BackgroundArray); begin end;
procedure SetBackground(byt:byte); begin end;
procedure DrawStraight(x1,x2,y:integer); begin end;
procedure SaveScreen(FileName:wrkstring); begin end;
procedure LoadScreen(FileName:wrkstring); begin end;
procedure SwapScreen; begin end;
procedure CopyScreen; begin end;
procedure InvertScreen; begin end;
procedure GotoXYTurbo(X,Y:integer); begin end;
procedure GotoXY(X,Y:integer); begin end;
procedure ClrEOLTurbo; begin end;
procedure ClrEOL; begin end;
procedure error(ErrProc,ErrCode:integer); begin end;
procedure SetBreakOff; begin end;
procedure SetBreakOn; begin end;
function GetErrorCode:byte; begin end;
procedure SetWindowModeOff; begin end;
procedure SetWindowModeOn; begin end;
procedure SetClippingOn; begin end;
procedure SetClippingOff; begin end;
procedure SetMessageOn; begin end;
procedure SetMessageOff; begin end;
procedure SetHeaderOn; begin end;
procedure SetHeaderOff; begin end;
procedure SetHeaderToTop; begin end;
procedure SetHeaderToBottom; begin end;
procedure RemoveHeader(i:integer); begin end;
procedure SetColorWhite; begin end;
procedure SetColorBlack; begin end;
function GetWindow:integer; begin end;
function GetColor:integer; begin end;
function clipping:boolean; begin end;
function WindowMode:boolean; begin end;
procedure SetScreenAspect(aspect:real); begin end;
function GetScreenAspect:real; begin end;
procedure SetAspect(aspect:real); begin end;
function GetAspect:real; begin end;
procedure SetLinestyle(ls:integer); begin end;
function GetLinestyle:integer; begin end;
procedure SetVStep(vs:integer); begin end;
function GetVStep:integer; begin end;
procedure DefineHeader(i:integer;hdr:wrkstring); begin end;
procedure SelectScreen(i:integer); begin end;
function GetScreen:byte; begin end;
procedure DefineWorld(i:integer;X_1,Y_1,X_2,Y_2:real); begin end;
procedure SelectWorld(i:integer); begin end;
procedure DefineWindow(i,X_1,Y_1,X_2,Y_2:integer); begin end;
function TextLeft(TX,Boundary:integer):integer; begin end;
function TextRight(TX,Boundary:integer):integer; begin end;
function TextUp(TX,Boundary:integer):integer; begin end;
function TextDown(TX,Boundary:integer):integer; begin end;
procedure DefineTextWindow(i,X1,Y1,X2,Y2,B:integer); begin end;
procedure SelectWindow(i:integer); begin end;
function WindowX(x:real):integer; begin end;
function WindowY(y:real):integer; begin end;
procedure InitGraphic;
  begin
    writeln('Programe compil avec la librairie graphique Dummy - Non xcutable');
    halt;
  end;
procedure ResetWindows; begin end;
procedure ResetWorlds; begin end;
function clip(var x1,y1,x2,y2:integer):boolean; begin end;
procedure DrawPoint(xr,yr:real); begin end;
function PointDrawn(xr,yr:real):boolean; begin end;
procedure DrawLine(x1,y1,x2,y2:real); begin end;
procedure DrawLineClipped(x1,y1,x2,y2:integer); begin end;
procedure DrawCrossDiag(x,y,scale:integer); begin end;
procedure DrawWye(x,y,scale:integer); begin end;
procedure DrawDiamond(x,y,scale:integer); begin end;
procedure DrawCircleDirect(xr,yr,r:integer; DirectModeLoc: boolean); begin end;
procedure DrawCircle(X_R,Y_R,xradius:real); begin end;
procedure DrawCross(x1,y1,scale:integer); begin end;
procedure DrawStar(x,y,scale:integer); begin end;
procedure DrawSquareC(x1,y1,x2,y2:integer;fill:boolean); begin end;
procedure DrawSquare(X1,Y1,X2,Y2:real;fill:boolean); begin end;
procedure DrawAscii(var x,y:integer;size,ch:byte); begin end;
procedure DrawText(x,y,scale:integer;txt:wrkstring); begin end;
procedure DrawTextW(x,y:real;scale:integer;txt:wrkstring); begin end;
procedure DrawBorder; begin end;
procedure hardcopy(inverse:boolean;mode:byte); begin end;
procedure MoveVer(delta:integer;FillOut:boolean); begin end;
procedure MoveHor(delta:integer;FillOut:boolean); begin end;
procedure CopyWindow(from,tu:byte;x1,y1:integer); begin end;
procedure SaveWindow(n:integer;FileName:wrkstring); begin end;
procedure LoadWindow(n,xpos,ypos:integer;FileName:wrkstring); begin end;
function WindowSize(win:integer):integer; begin end;
procedure ClearWindowStack(win:integer); begin end;
procedure StoreWindow(win:integer); begin end;
procedure RestoreWindow(win,DeltaX,DeltaY:integer); begin end;
procedure SaveWindowStack(FileName:wrkstring); begin end;
procedure LoadWindowStack(FileName:wrkstring); begin end;
procedure ResetWindowStack; begin end;
procedure InvertWindow; begin end;
procedure DrawCircleSegment(xr0,yr0:real;var xr1,yr1:real;
  inner,outer,phi,area:real;txt:wrkstring;prior,scale:byte); begin end;
procedure Hatch(X_1,Y_1,X_2,Y_2,Delta:real); begin end;
procedure DrawAxis(XDens,YDens,XLeft,YTop,XRight,YBottom,XAxis,YAxis:integer;
  HistoTyp:boolean); begin end;
procedure bezier(A:PlotArray;MaxContrPoints:integer;var B:PlotArray;
  MaxIntPoints:integer); begin end;
procedure FindWorld(i:integer;A:PlotArray;NPoints:integer;ScaleX,ScaleY:real);
  begin end;
procedure RotatePolygonAbout(Var A:PlotArray;NPoints:integer;
  Theta,X0,Y0:real); begin end;
procedure RotatePolygon(var A:PlotArray;NPoints:integer;Theta:real);
  begin end;
procedure TranslatePolygon(var A:PlotArray;N:integer;DeltaX,DeltaY:real);
  begin end;
procedure ScalePolygon(var A:PlotArray;N:integer;ScaleX,ScaleY:real);
  begin end;
procedure DrawPolygon(A:PlotArray;I0,NPoints,Line,Scale,Lines:integer);
  begin end;
procedure spline(A:PlotArray;N:integer;X1,XM:real;var B:PlotArray;M:integer);
  begin end;
procedure DrawHistogram(A:PlotArray;NPoints:integer;Hatching:boolean;
  HatchStyle:integer); begin end;
procedure DrawCartPie(X1,Y1,X2,Y2,Inner,Outer:real;A:PieArray;
  N,Prior,Scale:integer); begin end;
procedure DrawPolarPie(X1,Y1,Radius,Angle,Inner,Outer:real;A:PieArray;
  N,Prior,Scale:integer); begin end;
procedure RedefineWindow(i,X_1,Y_1,X_2,Y_2:integer); begin end;
