
program MovePolygon;

{$I typedef.sys}                       {ces fichiers doivent tre }
{$I graphix.sys}                       {inclus dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I polygon.hgh}
{$I modpoly.hgh}

var ArrowAngle: integer;
   Ch: char;
   Arrow: PlotArray;
   CurrX,CurrY,IncrX,IncrY,Size,Speed: real;
   ArrowIncr: array[0..7,1..2] of real;


procedure MakeArrow;
begin
  Arrow[1,1]:=0;            (* Initialisation de PlotArray pour la pointe de la flche *)
  Arrow[1,2]:=0;
  Arrow[2,1]:=Size;
  Arrow[2,2]:=-Size;
  Arrow[3,1]:=0;
  Arrow[3,2]:=Size;
  Arrow[4,1]:=-Size;
  Arrow[4,2]:=-Size;
  Arrow[5,1]:=0;
  Arrow[5,2]:=0;
end;

procedure MakeMoveTable;
begin
  ArrowIncr[0,1]:=0;   { valeurs de la vitesse pour les dplacements radiaux }
  ArrowIncr[0,2]:=1;
  ArrowIncr[1,1]:=-1;
  ArrowIncr[1,2]:=1;
  ArrowIncr[2,1]:=-1;
  ArrowIncr[2,2]:=0;
  ArrowIncr[3,1]:=-1;
  ArrowIncr[3,2]:=-1;
  ArrowIncr[4,1]:=0;
  ArrowIncr[4,2]:=-1;
  ArrowIncr[5,1]:=1;
  ArrowIncr[5,2]:=-1;
  ArrowIncr[6,1]:=1;
  ArrowIncr[6,2]:=0;
  ArrowIncr[7,1]:=1;
  ArrowIncr[7,2]:=1;
end;

procedure MoveForward;                {routine pour dplacer le polygone en avant }
begin
  SetColorBlack;                      {dessiner sur l'ancien polygone pour l'effacer}
  DrawPolygon(Arrow,1,-5,0,0,0);
  CurrX:=CurrX+IncrX;                 {aller  la nouvelle position}
  CurrY:=CurrY+IncrY;
  TranslatePolygon(Arrow,5,IncrX,IncrY);
  SetColorWhite;                      {dessiner le polugone  la nouvelle position}
  DrawPolygon(Arrow,1,-5,0,0,0);
end;

procedure MoveBack;                   {routine pour dplacement en arrire}
begin
  SetColorBlack;                      {idem ci-dessus}
  DrawPolygon(Arrow,1,-5,0,0,0);
  CurrX:=CurrX-IncrX;
  CurrY:=CurrY-IncrY;
  TranslatePolygon(Arrow,5,-IncrX,-IncrY);
  SetColorWhite;
  DrawPolygon(Arrow,1,-5,0,0,0);
end;

procedure TurnLeft;                    {rotation dans le sens contraire d'une montre}
begin
  SetColorBlack;                       {efface l'ancien polygone}
  DrawPolygon(Arrow,1,-5,0,0,0);
  RotatePolygon(Arrow,5,45);           {rotation de 45 degrs}
  ArrowAngle:=ArrowAngle+1;
  if ArrowAngle>7 then ArrowAngle:=0;
  IncrX:=Speed * ArrowIncr[ArrowAngle,1];  {choisir la nouvelle vitesse}
  Incry:=Speed * ArrowIncr[ArrowAngle,2];
  SetColorWhite;                       {dessiner le polygone aprs rotation}
  DrawPolygon(Arrow,1,-5,0,0,0);
end;

procedure TurnRight;                   {rotation dans le sens des aiguilles}
begin
  SetColorBlack;                       {idem ci-dessus}
  DrawPolygon(Arrow,1,-5,0,0,0);
  RotatePolygon(Arrow,5,-45);
  ArrowAngle:=ArrowAngle-1;
  if ArrowAngle<0 then ArrowAngle:=7;
  IncrX:=Speed * ArrowIncr[ArrowAngle,1];
  Incry:=Speed * ArrowIncr[ArrowAngle,2];
  SetColorWhite;
  DrawPolygon(Arrow,1,-5,0,0,0);
end;


begin

InitGraphic;                           {initialiser le systme graphique}

DefineWindow(1,0,0,XMaxGlb,YMaxGlb);

DefineWorld(1,-1000,1000,1000,-1000);  {dfinir un systme de coordonnes}

SelectWorld(1);                        {choisir le systme}
SelectWindow(1);                       {choisir la fentre}
SetBackground(0);                      {fond noir}

Size:=100;
Speed:=30;
CurrX:=0;
CurrY:=0;
ArrowAngle:=0;
IncrX:=0;
IncrY:=Speed;

MakeArrow;                             {dessiner la tte de la flche}
MakeMoveTable;                         {dfinir la table des dplacements}
DrawPolygon(Arrow,1,5,0,0,0);          {dessiner la flche pointant en haut}


repeat
  read(Kbd,Ch);                        {lire la touche tape}
  case ord(Ch) of
      72 : MoveForward;                {flche en haut ?}
      75 : TurnLeft;                   {flche  gauche ?}
      77 : TurnRight;                  {flche  droite ?}
      80 : MoveBack;                   {flche en bas?}
  end;
until Ch=' ';                          { la barre d'espace arrte le programme}

LeaveGraphic;                          {quitter le systme graphique }

end.
