

program PieHisto;

{$I typedef.sys}                         {ces fichiers doivent tre inclus }
{$I graphix.sys}                         {et dans cet ordre}
{$I kernel.sys}
{$I windows.sys}
{$I circsegm.hgh}
{$I pie.hgh}
{$I hatch.hgh}
{$I histogrm.hgh}


procedure PieHistoDem;

var sum,x1,y1,x2,y2,InRadius,OutRadius:real;
    i,n:integer;
    a:PieArray;
    b:PlotArray;
    ch:char;
    NumText:WrkString;

begin

  n:=5;                                  {nombre de valeurs}
  a[1].area:=25;                         {initialiser le camenbert}
  a[2].area:=17.5;
  a[3].area:=9.6;
  a[4].area:=21;
  a[5].area:=35;
  a[1].text:='JAN. ';
  a[2].text:='FEV. ';
  a[3].text:='MAR. ';
  a[4].text:='AVR. ';
  a[5].text:='MAI  ';


  for i:=1 to n do                        {initialiser l'histogramme}
    b[i,2]:=a[i].area;

  ClearScreen;
  SetColorWhite;

  DefineWindow(1,0,0,XMaxGlb,YMaxGlb);
  DefineHeader(1,'HISTOGRAMME ET CAMEMBERT ENSEMBLE');  {dfinit une fentre}
  SelectWindow(1);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;


  for i:=1 to n do          (* affiche les infos en haut  droite *)
   begin
    GotoXY(60,4+i);                       {se dplacer sur la ligne correcte }
    write(a[i].text,'=');
    str(a[i].area:6:2,NumText);           {formatter les donnes numriques   }
    write(NumText);                       {afficher les donnes numriques}
   end;


  DefineWindow(2,trunc(XMaxGlb/10),trunc(YMaxGlb/10),
                 trunc(XMaxGlb*6/10),trunc(YMaxGlb*7/10));
  DefineHeader(2,'CAMEMBERT');          {dfinit une fentre}
  DefineWorld(2,0,1000,1000,0);
  SelectWorld(2);
  SelectWindow(2);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  a[1].area:=-a[1].area;                 {faire ressortir le premier secteur}
  SetAspect(1.0);                        {fixer le facteur d'aspect}

  x1:=500;                               {centrer au milieu de l'cran}
  y1:=500;

  x2:=600;                               {fixer le point de dpart du cercle}
  y2:=350;

  InRadius:=0.7;                         {bornes des lignes d'identification}
  OutRadius:=1.25;

  DrawCartPie(x1,y1,x2,y2,InRadius,OutRadius,a,n,2,1); {tracer le camembert}

  a[1].area:=-a[1].area;                 { remettre le bon signe }

  DefineWindow(3,trunc(XMaxGlb/2),trunc(YMaxGlb/2),
                 trunc(XMaxGlb*9/10),trunc(YMaxGlb*9/10));
  DefineHeader(3,'HISTOGRAMME');         { dfinit une fentre }
  DefineWorld(3,0,60,10,0);
  SelectWorld(3);
  SelectWindow(3);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  DrawHistogram(b,n,true,5);

for i:=1 to n do
 begin
  DrawTextW((10/n)*(i-1),10,1,'   '+a[i].text);  {affiche le texte }
  str(a[i].area:6:2,NumText);                    {formatter les nombres }
  DrawTextW((10/n)*(i-1),16,1,' '+NumText);      {affiche les nombres }
 end;

end;



begin

InitGraphic;                             {initialiser le systme graphique }

PieHistoDem;                             {dmonstration}

repeat until keypressed;                 {attendre qu'une touche soit tape }

LeaveGraphic;                            {quitter le systme graphique }

end.

