(***********************************************************)
(*                                                         *)
(*                TURBO GRAPHIX version 1.05A              *)
(*                                                         *)
(*                Programme de demonstration               *)
(*                  Module version  1.03A                  *)
(*                                                         *)
(*                  Copyright (C) 1985 by                  *)
(*                  BORLAND International                  *)
(*                                                         *)
(***********************************************************)

{$C-}
program TurboGraphicsDemo;

{$I typedef.sys}
{$I graphix.sys}
{$I kernel.sys}
{$I windows.sys}
{$I hatch.hgh}
{$I findwrld.hgh}
{$I circsegm.hgh}
{$I axis.hgh}
{$I histogrm.hgh}
{$I pie.hgh}
{$I polygon.hgh}
{$I bezier.hgh}
{$I spline.hgh}

procedure delay(n: real);
var i:real;
    j:integer;
    ch:char;
    quit:boolean;

begin
  i:=0;
  ch:=' ';
  repeat
    i:=i+1;
    quit:=false;
    if keypressed then
     begin
      read(kbd,ch);
      quit:=(ch=^C);
      if (ch=^[) and keypressed then
       begin
        read(kbd,ch);
        quit:=(ch='O');
        ch:=' ';
       end;
     end;
    if quit then
     begin
      leavegraphic;
      halt;
     end;
  until (ch=^M) or (i>=n);
end;

procedure waitreturn(n: real);
begin
  write('tapez sur ENTER  ');
  delay(n);
end;

procedure ClearEol(i:integer);
begin
  gotoxy(1,i);
  write('                                                                               ');
end;

procedure msg(s:wrkstring);
begin
  ClearEol(25);
  gotoxy(1,25);
  write(s);
  delay(750);
end;

procedure SelectIBM;
begin
  SelectWorld(2);
  SelectWindow(10);
end;

procedure DefineWindowIBM(i,X1,Y1,X2,Y2:integer);
begin
  DefineWindow(i,Trunc(X1/79*XMaxGlb+0.001),Trunc(Y1/199*YMaxGlb+0.001),
                 Trunc(X2/79*XMaxGlb+0.5),Trunc(Y2/199*YMaxGlb+0.5));
end;

procedure MoveHorIBM(delta:integer;fill:boolean);
var d:integer;
begin
  d:=Trunc(abs(delta)/79*XMaxGlb+0.001);
  if delta<0 then d:=-d;
  MoveHor(d,fill);
end;

procedure MoveVerIBM(delta:integer;fill:boolean);
var d:integer;
begin
  d:=Trunc(abs(delta)/199*YMaxGlb+0.001);
  if delta<0 then d:=-d;
  MoveVer(d,fill);
end;

{----------------------------------------------------------------------------}

overlay procedure intro;
var i:integer;
begin
  SetHeaderOff;
  DefineWindowIBM(1,5,40,25,80);
  DefineWindowIBM(2,16,55,43,95);
  DefineWindowIBM(4,15,60,43,135);

  SelectWindow(1);
  DrawBorder;
  SelectIBM;
  DrawTextW(52,55,5,'TURBO');
  StoreWindow(1);
  delay(500);

  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  SelectIBM;
  DrawTextW(140,70,5,'GRAPHIX');
  StoreWindow(2);
  delay(500);

  for i:=1 to 4 do
  begin
    RestoreWindow(1,0,0);
    delay(800);
    RestoreWindow(2,0,0);
    delay(800);
  end;

  for i:=1 to 8 do
  begin
    RestoreWindow(1,trunc(3*i*XMaxGlb/79),trunc(9*i*YMaxGlb/199));
    delay(500);
    RestoreWindow(2,trunc(3*i*XMaxGlb/79),trunc(9*i*YMaxGlb/199));
    delay(500);
  end;

  delay(500);

  SelectWindow(4);
  StoreWindow(4);
  SetBackground(0);
  DrawBorder;
  gotoxy(18,09);
  writeln('PROCEDURES GRAPHIQUES');
  gotoxy(18,10);
 writeln('POUR TURBO PASCAL    ');
  for i:=2 to 40 do
   begin
    DrawLine(i*8,60,639-i*8,190);
    DrawLine(639-i*8,60,i*8,190);
   end;
  delay(2500);

  RestoreWindow(4,0,0);

  InvertScreen;
  SelectScreen(2);
  ClearScreen;
  InvertScreen;
  SetColorBlack;
  SelectIBM;
  DrawTextW(40,75,3,'De');
  DrawTextW(40,140,4,'BORLAND INTERNATIONAL');

  CopyScreen;

  SelectScreen(1);
  delay(5000);
  DefineWindowIBM(1,1,125,35,168);
  StoreWindow(1);
  DefineWindowIBM(2,36,125,78,168);
  StoreWindow(2);

  for i:=1 to trunc(34*XMaxGlb/79) do
  begin
    SelectWindow(1);
    MoveHor(1,false);
    ReDefineWindow(1,X1RefGlb,Y1RefGlb,X2RefGlb-1,Y2RefGlb);
    SelectWindow(2);
    MoveHor(-1,false);
    ReDefineWindow(2,X1RefGlb+1,Y1RefGlb,X2RefGlb,Y2RefGlb);
  end;

  delay(1000);
  RestoreWindow(1,0,0);
  RestoreWindow(2,0,0);

  GotoXY(1,25);
  ClrEol;
  GotoXY(17,25);
  Write('Copyright (C) 1985 Borland International, Inc.');
  delay(3000);
  SetColorWhite;
  SetHeaderOn;
end;

{----------------------------------------------------------------------------}

overlay procedure simple;
var i,j,rnd:integer;
    rad:real;
    ch:char;

procedure DrawPoints;
var i:integer;
begin
  SetBackground(0);
  DrawBorder;
  for i:=1 to 250 do DrawPoint(random(640),random(200));
end;

procedure DrawLines;
var i:integer;
begin
  SetBackground(0);
  DrawBorder;
  for i:=1 to 20 do DrawLine(i*31,0,640-i*31,i*10);
end;

procedure DrawSquares;
var i:integer;
begin
  SetBackground(0);
  DrawBorder;
  for i:=1 to 15 do DrawSquare(320-i*20,100-i*6,320+i*20,100+i*6,false);
end;

procedure DrawCircles;
var i:integer;
    AspectLoc:real;
Begin
  SetBackground(0);
  DrawBorder;
  rad:=0.8;
  AspectLoc:=GetAspect;
  SetAspect(1/4.5);
  for i:=1 to 15 do
  begin
    DrawCircle(320,100,rad);
    SetAspect((1+i)/4.5);
    rad:=rad-0.05;
  end;
  SetAspect(AspectLoc);
end;

procedure DrawPie1;
var a:PieArray;
    i:integer;
begin
  SetBackground(0);
  DrawBorder;
  for i:=1 to 5 do
  begin
    a[i].area:=random+0.35;
    a[i].text:='';
  end;
  a[2].area:=-a[2].area;
  DrawCartPie(320,100,500,100,1,1,a,5,0,1);
end;

procedure HatchIt;
var i,temp,x1,x2,y1,y2:integer;
begin
  SetBackground(0);
  DrawBorder;
  for i:=1 to 5 do
  begin
    x1:=100+random(500);
    x2:=100+random(500);
    y1:=30+random(160);
    y2:=30+random(160);
    if x1>x2 then begin temp:=x1;x1:=x2;x2:=temp; end;
    if y1>y2 then begin temp:=y1;y1:=y2;y2:=temp; end;
    DrawSquare(x1,y1,x2,y2,false);
    hatch(x1,y1,x2,y2,random(6)+5);
  end;
end;

begin
  ClearScreen;
  SetHeaderOn;
  DefineWindowIBM(1,0,0,79,185);
  DefineHeader(1,'Procedures graphiques simples');
  SelectWindow(1);
  SetBackground(90);
  DrawBorder;
  CopyScreen;

  DefineWindowIBM(2,28,60,49,140);
  SelectWindow(2);
  msg('  trac de points   :   DrawPoint');
  DrawPoints;
  MoveVerIBM(-44,true);
  MoveHorIBM(-26,true);
  delay(1000);

  DefineWindowIBM(3,28,60,49,140);
  SelectWindow(3);
  msg('  trac de lignes   :   DrawLine');
  DrawLines;
  MoveVerIBM(-44,true);
  CopyScreen;
  delay(1000);

  DefineWindowIBM(4,28,60,49,140);
  SelectWindow(4);
  msg('  trac de carrs   :   DrawSquare');
  DrawSquares;
  MoveVerIBM(-44,true);
  MoveHorIBM(26,true);
  delay(1000);

  DefineWindowIBM(5,28,60,49,140);
  SelectWindow(5);
  msg('  trac de cercles et d''llipses  :   DrawCircle');
  DrawCircles;
  MoveVerIBM(40,true);
  MoveHorIBM(26,true);
  delay(1000);

  DefineWindowIBM(6,28,60,49,140);SelectWindow(6);
  msg('  Trac d''arcs de cercles   :   DrawCircleSegment');
  DrawPie1;
  MoveVerIBM(40,true);
  CopyScreen;
  delay(1000);

  DefineWindowIBM(7,28,60,49,140);
  SelectWindow(7);
  msg(' hachurage    :   hatch');
  HatchIt;
  MoveVerIBM(40,true);
  MoveHorIBM(-26,true);
  delay(1000);
  ClearEol(25);

  for i:=1 to 5 do
  begin
    SelectWindow(2);
    InvertWindow;
    for j:=3 to 7 do
     begin
      SelectWindow(j);
      InvertWindow;
      SelectWindow(j-1);
      InvertWindow;
     end;
    SelectWindow(7);
    InvertWindow;
  end;

  msg('              tapez sur ENTER  ');
  for i:=2 to 7 do begin SelectWindow(i); InvertWindow; end;
  i:=0;
  ch:=' ';
  repeat
    rnd:=random(6)+1;
    SelectWindow(rnd+1);
    case rnd of
      1:DrawPoints;
      2:DrawLines;
      3:DrawSquares;
      4:DrawCircles;
      5:DrawPie1;
      6:HatchIt;
    end;
    InvertWindow;
    i:=i+1;
    if keypressed then read(kbd,ch);
  until (ch=^M) or (i=30);
end;

{----------------------------------------------------------------------------}

overlay procedure WindowDemo;
var row,column,i:integer;

procedure WriteSlow(s:wrkstring);
begin
  row:=row+1;
  gotoxy(17,5);
  write(row:2);
  gotoxy(8,6+row);
  for i:=1 to length(s) do
  begin
    write(s[i]);
    gotoxy(28,5);
    write(column+i:2);
    gotoxy(8+i,6+row);
    delay(10+random(100));
  end;
end;

begin
  ClearScreen;
  SetHeaderOn;
  DefineWindowIBM(1,0,0,79,190);
  DefineHeader(1,'Utilisation de plusieurs fenetres sur un ecran');
  SelectWindow(1);
  SetBackground(24);
  DrawBorder;

  DefineWindowIBM(2,4,16,55,140);
  DefineHeader(2,'Exemple:  Edition');

  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  column:=0;row:=0;
  gotoxy(11,5);write('Ligne     Colonne     Fichier : A:TEST.TXT');
  gotoxy(8,6);write('L----#----#-----#----#----#----#----#----#----R');
  gotoxy(8,7);WriteSlow ('Ceci est une dmonstration d''utilisation ');
  gotoxy(8,8);WriteSlow ('des fentres avec le systme GRAPHIX. Une ');
  gotoxy(8,9);WriteSlow ('fentre est une partie dfinie de l''cran.');
  gotoxy(8,10);WriteSlow('Toutes les commandes graphiques subsquentes ');
  gotoxy(8,11);WriteSlow('rferent  cette fentre. Les parties du  ');
  gotoxy(8,12);WriteSlow('diagramme hors de la fentre ne sont pas  ');
  gotoxy(8,13);WriteSlow('dessines. Les chelles sont aussi faites ');
  gotoxy(8,14);WriteSlow('par GRAPHIX, vous permettant de dessiner  ');
  gotoxy(8,15);WriteSlow('en coordonnes propres.');
  gotoxy(19,16);
  StoreWindow(2);
  waitreturn(60000.0);

  DefineWindowIBM(3,25,30,78,180);
  DefineHeader(3,'Exemple: diagrammes');
  SelectWindow(3);
  SetBackground(0);
  DrawBorder;
  gotoxy(28,7);
  write('        1        2        3        4        5');
  for i:=1 to 12 do
  begin
    gotoxy(28,7+i);
    write(i:2);
  end;
  gotoxy(28,20);write('Commande ? _________________________________________');
  gotoxy(28,22);write('en cours : ventes.clc     libre : 85 koctet = 92.3 %');
  gotoxy(40,9);write(' V E N T E S  1984');
  gotoxy(40,10);write(' ===============================');
  gotoxy(32,12);write('cot de production      :   1456.35');
  gotoxy(32,13);write('cot du personnel       :    145.23');
  gotoxy(32,14);write('Taxes diverses          :    524.12');
  gotoxy(32,15);write('-----------------------------------');
  gotoxy(32,16);write('Sous total              :   2125.70');
  gotoxy(32,18);write('Solde                   :    145.00');
  delay(4000);
  gotoxy(39,20);
  waitreturn(15000);

  DefineWindowIBM(4,12,60,68,164);
  DefineHeader(4,'Exemple:  Graphismes');
  SelectWindow(4);
  SetBackground(0);
  DrawBorder;
  for i:=1 to 85 do DrawLine(20+i*7,30,630-i*7,170);
  gotoxy(29,20);
  CopyScreen;
  waitreturn(15000);

  RestoreWindow(2,trunc(16*XMaxGlb/79),trunc(32*YMaxGlb/199));
  SelectWindow(2);
  delay(2000);
  MoveHorIBM(-16,true);
  MoveVerIBM(-32,true);
  for i:=1 to 11 do
  begin
    gotoxy(8,6+i);
    write('                                              ');
  end;
  row:=0;
  column:=0;
  gotoxy(8,7); WriteSlow('Vous pouvez aussi dplacer les fentres    ');
  gotoxy(8,8); WriteSlow('l''intrieur de l''cran. Vous pouvez les faire');
  gotoxy(8,9); WriteSlow('glisser les unes sur les autres ou les mettre');
  gotoxy(8,10);WriteSlow('l''une au-dessus de l''autre.Une fentre peut');
  gotoxy(8,11);WriteSlow('tre mise en mmoire de fentre et tre ramene');
  gotoxy(8,12);WriteSlow('sur l''cran au fur et  mesure des besoins ');
  gotoxy(8,13);WriteSlow('La taille de la mmoire de fentre est seulement');
  gotoxy(8,14);WriteSlow('limite par celle de la mmoire principale.     ');
  gotoxy(19,16);
  waitreturn(60000.0);
end;

{----------------------------------------------------------------------------}

overlay procedure sier;
const n=4;
var i,h,x,y,x0,y0:integer;
    sec:boolean;

procedure plot;
begin
  if sec then SetColorWhite else SetColorBlack;
  DrawLine(x,y,x0,y0);
  DrawLine(x+256,y+256,x0+256,y0+256);
  if sec then SetColorBlack else SetColorWhite;
  DrawLine(x+256,y,x0+256,y0);
  DrawLine(x,y+256,x0,y0+256);
  x0:=x;
  y0:=y;
end;


procedure b(i:integer); forward;

procedure c(i:integer); forward;

procedure d(i:integer); forward;

procedure a(i:integer);
begin
  if i>0 then
  begin
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
    x:=x+2*h;
    plot;
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
    a(i-1);
  end;
end;

procedure b;
begin
  if i>0 then
  begin
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
    y:=y-2*h;
    plot;
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
  end;
end;

procedure c;
begin
  if i>0 then
  begin
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
    x:=x-2*h;
    plot;
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
  end;
end;

procedure d;
begin
  if i>0 then
  begin
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
    a(i-1);
    y:=y+2*h;
    plot;
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
  end;
end;

procedure DoIt;
begin
  i:=3;
  h:=16;
  x0:=30;
  y0:=240;
  repeat
    i:=i+1;
    x0:=x0-h;
    h:=h div 2;
    y0:=y0+h;
    x:=x0;
    y:=y0;
    a(i-1);
    x:=x+h;
    y:=y-h;
    plot;
    b(i-1);
    x:=x-h;
    y:=y-h;
    plot;
    c(i-1);
    x:=x-h;
    y:=y+h;
    plot;
    d(i-1);
    x:=x+h;
    y:=y+h;
    plot;
  until i=n;
end;

begin
  SetHeaderOn;
  DefineWorld(1,-3,514,514,-3);
  SelectWorld(1);
  DefineWindowIBM(2,0,0,39,99);
  SelectWindow(2);
  InvertWindow;
  DefineWindowIBM(2,40,100,79,190);
  SelectWindow(2);
  InvertWindow;
  DefineWindowIBM(1,0,0,79,190);
  DefineHeader(1,'Une courbe de Sierpinski');
  SelectWindow(1);
  DrawBorder;
  gotoxy(1,25);
  write('     L''cran complet est la fentre prsente');
  sec:=false;
  DoIt;
  gotoxy(57,25);
  waitreturn(15000);

  DefineWindowIBM(1,20,40,59,159);
  RemoveHeader(1);
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;
  DefineWindowIBM(2,40,40,59,99);
  SelectWindow(2);
  InvertWindow;
  DefineWindowIBM(2,20,100,39,159);
  SelectWindow(2);
  InvertWindow;
  SelectWindow(1);
  ClearEol(25);
  gotoxy(1,25);
  write('  Les mmes dessins dans une fentre plus petite');
  sec:=true;
  DoIt;
  gotoxy(57,25);
  waitreturn(15000);

  ClearEol(25);
  gotoxy(1,25);
  write('   L''cran est sauvegard avec la procdure SaveScreen , ...');
  SaveScreen('TEST.PIC');
  delay(1000);
  ClearScreen;
  delay(1000);
  LoadScreen('TEST.PIC');
  ClearEol(25);
  gotoxy(1,25);
  write('     ... et rappel.');
  gotoxy(57,25);
  waitreturn(15000);
  DefineWorld(1,0,199,639,0);
  SelectWorld(1);
  SelectWindow(1);
  SetColorWhite;
end;

{----------------------------------------------------------------------------}

overlay procedure PieDem;
var sum:real;
    i,j,n:integer;
    a:PieArray;

begin
  ClearScreen;
  SetColorWhite;

  DefineWindowIBM(1,0,0,79,185);
  DefineWindowIBM(2,20,20,77,180);
  DefineWindowIBM(3,28,60,59,150);
  DefineWindowIBM(4,28,60,59,140);
  DefineWindowIBM(5,28,60,59,140);
  DefineWindowIBM(6,28,60,59,140);

  DefineHeader(1,'Les applications avec camembert');
  DefineHeader(2,'Volume des ventes');
  DefineHeader(3,'Avec texte');
  DefineHeader(4,'Avec texte');
  DefineHeader(5,'Avec texte et nombres');
  DefineHeader(6,'Sans texte');

  a[1].area:=25;
  a[1].text:='JAN. ';
  a[2].area:=17.5;
  a[2].text:='FEV. ';
  a[3].area:=9.6;
  a[3].text:='MAR. ';
  a[4].area:=21;
  a[4].text:='AVR. ';
  a[5].area:=35;
  a[5].text:='MAI  ';

  n:=5;
  sum:=0;
  for i:=1 to n do
    begin
      a[i].area:=a[i].area+5.35;
      sum:=sum+a[i].area;
    end;

  SelectWindow(1);
  DrawBorder;
  gotoxy(24,5);
  writeln('VENTES 1985');
  gotoxy(5,8);
  write('Montants en F (x 1,000,000)');
  gotoxy(40,8);
  write('Montants en pourcentage');
  for i:=1 to n do
   begin
    gotoxy(11,9+i);
    writeln(a[i].text,'  ',a[i].area:3:2,'                            ',a[i].area/sum*100:3:2);
   end;

  msg('  Dessin en arrire plan sur le second cran :  SelectScreen');
  SelectScreen(2);
  ClearScreen;
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  a[1].area:=-a[1].area;
  DrawCartPie(300,100,390,73,1.05,1.5,a,n,2,2);
  ResetWindowStack;
  StoreWindow(2);
  SelectScreen(1);
  RestoreWindow(2,0,0);

  delay(15000);

  CopyScreen;
  msg('Les variantes d''un camembert : DrawCartPie');
  SetColorBlack;
  SelectWindow(3);
  SetBackground(255);
  DrawBorder;
  a[4].area:=-a[4].area;
  DrawCartPie(320,100,437,73,1.05,1.6,a,n,1,1);
  a[4].area:=-a[4].area;
  MoveVerIBM(-32,true);
  MoveHorIBM(-26,true);
  CopyScreen;
  delay(1000);

  SelectWindow(4);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320,100,437,73,0.75,1.5,a,n,1,1);
  MoveVerIBM(-44,true);
  MoveHorIBM(19,true);
  delay(1000);
  CopyScreen;

  SelectWindow(5);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320,100,437,100,0.7,1.4,a,n,2,1);
  MoveVerIBM(30,true);
  MoveHorIBM(-18,true);
  delay(1000);

  SelectWindow(6);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320,100,482,73,1,1.5,a,n,0,1);
  delay(1000);

  delay(15000);

  RestoreWindow(2,0,0);

  delay(15000);
  SetColorWhite;
end;

{----------------------------------------------------------------------------}

overlay procedure SplineDem;
var x,temp:real;
    m,dx,dy,i,j,n,lines,scale:integer;
    X1,Y1,X2,Y2:integer;
    b,a:PlotArray;
begin
  ClearScreen;
  SetColorWhite;
  gotoxy(50,25);
  write('un moment S.V.P ....');
  dx:=-8;
  dy:=7;
  X1:=3;
  Y1:=5;
  X2:=25;
  Y2:=10;
  lines:=0;
  scale:=0;
  n:=12;
  m:=50;
  x:=-49;

  DefineWindowIBM(1,0,0,79,185);
  DefineWindowIBM(2,30,20,70,164);

  DefineHeader(1,'Interpolation : Spline');
  DefineHeader(2,'Une variante du diagramme');

  x:=-49;
  for i:=1 to n do
    begin
      a[i,1]:=i-1;
      a[i,2]:=random-0.5;
      x:=x+7;
    end;

  spline(a,n,a[2,1],a[n-1,1],b,m);
  FindWorld(1,b,m,1,1.08);

  SelectWindow(1);
  ClearEol(25);
  gotoxy(10,25);
  write('L''information donne');
  FindWorld(1,b,m,1,1.08);
  SelectWindow(1);
  DrawBorder;
  DrawAxis(dx,dy,X1,Y1,X2,Y2,lines,scale,false);
  SetLineStyle(1);
  DrawPolygon(a,2,n-1,7,2,0);
  SetLineStyle(0);
  SelectIBM;
  DrawTextW(470,70,1,^['7@2   Les donnees');
  DrawTextW(470,90,1,'-- Les valeurs interpolees');
  gotoxy(50,25);
  SelectWorld(1);
  SelectWindow(1);

  waitreturn(15000);

  ClearEol(25);
  gotoxy(10,25);
  write('La fonction spline d''interpolation');
  DrawAxis(0,0,X1,Y1,X2,Y2,0,0,false);
  DrawPolygon(b,1,-m,0,0,0);

  CopyScreen;
  gotoxy(50,25);
  waitreturn(15000);

  ClearEol(25);
  gotoxy(10,25);
  write('Coordonnes Verticales changes');
  with world[1] do
   begin
    temp:=y1;
    y1:=y2;
    y2:=temp;
   end;
  SelectWorld(1);
  SelectWindow(2);
  SetBackground(255);
  SetColorBlack;
  DrawBorder;
  DrawAxis(abs(dx),abs(dy),0,0,0,0,0,0,false);
  DrawPolygon(a,2,n-1,-2,2,-1);
  DrawAxis(0,0,0,0,0,0,0,0,false);
  DrawPolygon(b,1,-m,0,0,0);
  SetColorWhite;
  gotoxy(50,25);
  waitreturn(15000);

  ClearEol(25);
  gotoxy(10,25);
  write('Dplacement d''une fentre');
  MoveVerIBM(-15,true);
  MoveHorIBM(-30,true);
  MoveVerIBM(35,true);
  MoveHorIBM(35,true);
  MoveVerIBM(-5,true);
  MoveHorIBM(-5,true);
  gotoxy(50,25);
  waitreturn(15000);

  ClearEol(25);
  gotoxy(10,25);
  write('Inversion d''une fentre');
  InvertWindow;
  SetColorWhite;
  gotoxy(50,25);
  waitreturn(15000);

  SelectScreen(2);
  ClearEol(25);
  gotoxy(10,25);
  write('La reconstruction de la premiere figure');
  CopyScreen;
  SelectScreen(1);
  gotoxy(50,25);
  waitreturn(15000);
end;

{----------------------------------------------------------------------------}

overlay procedure PolygonDem;
var n:integer;
    b,a:PlotArray;
    x1,x2:integer;

procedure GenerateFunction(var a,b:PlotArray;n:integer);
var i:integer;
    delta:real;
begin
  delta:=2*pi/(n-1);
  for i:=1 to n do
    begin
      a[i,1]:=(i-1)*delta-pi;
      b[i,1]:=a[i,1];
      b[i,2]:=exp(-abs(a[i,1]));
      a[i,2]:=sin(a[i,1])*exp(-abs(a[i,1])*0.1);
    end;
end;
begin
  ClearScreen;
  SetColorWhite;
  n:=30;
  gotoxy(50,25);
  write('un moment S.V.P....');
  GenerateFunction(a,b,n);
  ClearScreen;
  DefineWorld(1,-pi,1,pi,-1);
  SelectWorld(1);

  msg('La fonction exemple en coordonnes propres  [-Pi,Pi] : DrawPolygon');
  DefineWindowIBM(1,0,0,39,95);
  DefineHeader(1,'La fonction exemple');
  SelectWindow(1);
  DrawBorder;
  DrawPolygon(a,1,n,0,0,0);

  delay(15000);

  msg('Procdures utilises : DrawAxis , DrawPolygon');
  DefineWindowIBM(2,20,40,79,185);
  DefineHeader(2,'Fonction exemple avec axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8,-8,0,0,0,0,0,0,false);
  DrawPolygon(a,1,n,0,0,0);

  delay(15000);

  msg('Axe de densit maximum : DrawAxis , DrawPolygon');
  DefineWindowIBM(2,8,15,70,170);
  DefineHeader(2,'Fonction exemple avec axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(9,-9,0,0,0,0,1,1,false);
  DrawPolygon(a,1,n,0,0,0);

  delay(15000);

  msg('La fonction exemple affiche point  point : DrawPolygon');
  DefineWindowIBM(1,0,0,39,95);
  DefineHeader(1,'La fonction exemple');
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;
  DrawPolygon(a,1,n,9,1,0);

  delay(15000);

  msg('La fonction exemple dessine avec des cercles : DrawPolygon');
  DrawPolygon(a,1,n,-8,3,0);

  delay(15000);

  msg('La fonction exemple relie par des lignes : SetLinestyle , DrawPolygon');
  SetLinestyle(1);
  DrawPolygon(a,1,n,0,0,0);
  SetLinestyle(0);

  delay(15000);

  msg('Affichage de plusieurs fonctions par appels rpets de DrawPolygon');
  DefineWindowIBM(2,20,40,79,185);
  DefineHeader(2,'Deux fonctions affichees avec les axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8,-8,0,0,0,0,0,0,false);
  DrawPolygon(a,1,n,-1,4,0);

  delay(15000);

  msg('Les points de la premire fonction relis avec des lignes : DrawPolygon');
  DrawAxis(0,0,0,0,0,0,0,0,false);
  DrawPolygon(a,1,n,0,0,0);

  delay(15000);

  msg('Les points de la seconde fonction dans le mme systme de coordonnes');
  DrawAxis(0,0,0,0,0,0,0,0,false);
  DrawPolygon(b,1,n,-4,2,0);

  delay(15000);

  msg('Les points de la seconde fonction relis avec des lignes : DrawPolygon');
  DrawAxis(0,0,0,0,0,0,0,0,false);
  SetLinestyle(1);
  DrawPolygon(b,1,n,0,0,0);
  SetLinestyle(0);

  delay(15000);

  msg('Lettrage des axes avec la plus grande densit : DrawAxis , DrawPolygon');
  DefineWindowIBM(2,8,15,70,170);
  DefineHeader(2,'Marquage des points');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8,-8,0,0,0,0,0,1,false);
  DrawPolygon(a,1,n,-2,3,0);

  delay(15000);

  DrawAxis(0,0,0,0,0,0,-1,-1,false);
  DrawPolygon(a,1,n,9,1,-1);

  delay(15000);

  DrawAxis(0,0,0,0,0,0,-1,-1,false);
  SetLinestyle(2);
  DrawPolygon(a,1,n,0,0,0);
  SetLinestyle(0);

  delay(15000);
end;

{----------------------------------------------------------------------------}

overlay procedure HistoDem;
var i,n:integer;
    a:PlotArray;
    r,temp:real;

begin
  gotoxy(50,25);
  write('Un moment S.V.P ....');
  n:=50;
  r:=abs(n/2);
  for i:=0 to abs(n-1) do
    begin;
      a[i+1,1]:=i-r;
      a[i+1,2]:=sin(a[i+1,1]/10)*exp(-abs(a[i+1,1])*0.01)+random*0.1;
    end;
  ClearScreen;
  SetColorWhite;

  DefineWindowIBM(1,0,0,79,185);
  DefineWindowIBM(2,20,20,75,175);
  DefineWindowIBM(3,5,35,60,170);
  DefineWindowIBM(4,10,50,55,165);

  DefineHeader(1,'Un histogramme en mode valeur absolue ');
  DefineHeader(2,'Un histogramme en mode normal');
  DefineHeader(3,'Un histogramme en mode normal avec hachurage');
  DefineHeader(4,'Un histogramme avec axes');

  msg('Affichage des montants : DrawHistogram');
  FindWorld(1,a,n,1.1,1.1);
  with world[1] do     { Renversement vertical du systme propre trouv }
   begin
    temp:=y1;
    y1:=y2;
    y2:=temp;
   end;
  SelectWorld(1);
  SelectWindow(1);
  DrawBorder;
  DrawHistogram(a,n,false,5);

  delay(15000);

  msg('Affichage des valeurs positives et ngatives : DrawHistogram');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawHistogram(a,-n,false,5);

  delay(15000);

  msg('La densit du hachurage peut tre rgle : DrawHistogram');
  SelectWindow(3);
  SetBackground(0);
  DrawBorder;
  DrawHistogram(a,-n,true,4);

  delay(15000);

  msg('La densit des axes est rglable : DrawAxis , DrawHistogram');
  SelectWindow(4);
  SetBackground(0);
  DrawBorder;
  DrawAxis(7,-7,0,0,0,0,0,0,true);
  DrawHistogram(a,-n,true,2);

  delay(15000);
end;

{----------------------------------------------------------------------------}

overlay procedure FlowChartDem;
var x1,y1,x2,y2,i,count:integer;
procedure DrawArrowHor(x1,y1,x2,y2:integer);
begin
  DrawLine(x1,y1,x2,y2);
  if x2>x1 then
   begin
    DrawLine(x2-4,y2-2,x2,y2);
    DrawLine(x2-4,y2+2,x2,y2);
   end
  else
   begin
    DrawLine(x2+5,y2-2,x2,y2);
    DrawLine(x2+5,y2+2,x2,y2);
   end;
end;
procedure DrawArrowVer(x1,y1,x2,y2:integer);
begin
  DrawLine(x1,y1,x2,y2);
  if y2>y1 then
   begin
    DrawLine(x2-2,y2-3,x2,y2);
    DrawLine(x2+2,y2-3,x2,y2);
   end
  else
   begin
    DrawLine(x2-2,y2+3,x2,y2);
    DrawLine(x2+2,y2+3,x2,y2);
   end;
end;
procedure blink(count,time:integer);
var i:integer;
begin
  for i:=1 to count do
   begin
    delay(time);
    InvertWindow;
   end;
end;

begin
  DefineWindowIBM(1,0,0,79,185);
  DefineWindowIBM(2,12,20,25,40);
  DefineWindowIBM(3,15,55,22,75);
  DefineWindowIBM(4,11,110,26,130);
  DefineWindowIBM(5,47,90,56,110);

  DefineHeader(1,'Un organigramme');
  SetColorWhite;
  SetHeaderOn;
  SelectWindow(1);
  DrawBorder;
  SetHeaderOff;

  SelectWindow(2);
  DrawBorder;
  SelectIBM;
  DrawTextW(125,27,2,'Debut');
  DrawArrowVer(151,40,151,55);

  SelectWindow(3);
  DrawBorder;
  SelectIBM;
  DrawTextW(136,63,2,'I=1');
  DrawArrowVer(151,75,151,110);

  SelectWindow(4);
  DrawBorder;
  SelectIBM;
  DrawTextW(108,118,2,'If I<=5');
  DrawLine(215,120,417,120);
  DrawArrowVer(417,120,417,110);
  DrawArrowVer(151,130,151,155);
  SelectIBM;
  DrawTextW(300,110,2,'OUI');
  DrawTextW(160,137,2,'NON');

  SelectWindow(5);
  DrawBorder;
  SelectIBM;
  DrawTextW(390,98,2,'I=I+1');
  DrawLine(417,80,417,90);
  DrawArrowHor(417,80,151,80);
  DrawCircle(151,165,0.25);
  DrawTextW(137,163,2,'Fin');
  SetHeaderOn;

  CopyScreen;

  ClearEol(25);
  gotoxy(27,25);

  DefineWindowIBM(2,15,21,22,39);
    SelectWindow(2);
    SetBackground(0);
    DrawBorder;
    InvertWindow;
    delay(1000);
    InvertWindow;
    MoveVerIBM(35,true);
    SelectIBM;
    DrawTextW(139,63,2,'I=1');
    SelectWindow(2);
    blink(30,50);
    MoveVerIBM(55,true);
    for count:=2 to 6 do
    begin
      delay(500);
      MoveHorIBM(33,true);
      MoveVerIBM(-20,true);
      SetBackground(0);
      DrawBorder;
      SelectIBM;
      DrawTextW(400,98,2,'I='+chr(48+count));
      SelectWindow(2);
      blink(30,50);
      MoveVerIBM(-20,true);
      MoveHorIBM(-33,true);
      MoveVerIBM(40,true);
    end;
    InvertWindow;
    delay(1000);
    MoveVerIBM(46,true);
    blink(30,50);
    MoveHorIBM(45,true);
    MoveVerIBM(-136,true);
    MoveHorIBM(-45,true);
    SetHeaderOn;
end;

{----------------------------------------------------------------------------}

overlay procedure BezierDem;
const MaxControlPoints=7;
      MaxIntPoints=15;
var i:integer;
    dummyx,dummyy:real;
    a,b:PlotArray;

Begin
  a[1,1]:=1;a[2,1]:=1.5;a[3,1]:=2;a[4,1]:=2.5;a[5,1]:=3;a[6,1]:=4;a[7,1]:=5;
  a[1,2]:=2;a[2,2]:=1.5;a[3,2]:=1;a[4,2]:=2.5;a[5,2]:=4;a[6,2]:=4.5;a[7,2]:=5;
  ClearScreen;
  SetColorWhite;
  DefineWorld(1,0,6,6,0);
  SelectWorld(1);
  DefineWindowIBM(1,0,0,79,170);
  SelectWindow(1);
  SetBackground(0);
  DefineHeader(1,'Une demonstration de modelisation et de graphismes');
  DrawBorder;
  repeat
    SetLinestyle(1);
    DrawPolygon(a,1,MaxControlPoints,4,2,0);
    bezier(a,MaxControlPoints,b,MaxIntPoints);
    SetLinestyle(0);
    DrawPolygon(b,1,MaxIntPoints,0,0,0);
    repeat
      ClearEol(23);
      gotoxy(1,23);
      write('Entrez le numro du point  changer :');
      i:=0;
      {$I-} read(i); {$I+}
      if IOResult<>0 then i:=0;
    until i in [0..MaxControlPoints];
    if i>0 then
      begin
        repeat
          gotoxy(1,24);
          clreol;
          write('Ancienne position : [',a[i,1]:4:2,',',a[i,2]:4:2,']');
          dummyx:=a[i,1];
          dummyy:=a[i,2];
          repeat
            gotoxy(40,24);
            clreol;
            write('   Nouvelle position  x: ');
            {$I-} read(dummyx); {$I+}
          until IOResult=0;
          repeat
            gotoxy(40,25);
            clreol;
            write('   Nouvelle position  y: ');
            {$I-} read(dummyy); {$I+}
          until IOResult=0;
        until ((dummyx>=X1WldGlb) and (dummyx<=X2WldGlb)) and ((dummyy>=Y1WldGlb) and (dummyy<=Y2WldGlb));
        SetLinestyle(1);
        SetColorBlack;
        DrawPolygon(a,1,MaxControlPoints,4,2,0);
        SetLinestyle(0);
        DrawPolygon(b,1,MaxIntPoints,0,0,0);
        a[i,1]:=dummyx;
        a[i,2]:=dummyy;
        SetColorWhite;
      End;
  until i=0;
end;

{----------------------------------------------------------------------------}

overlay function menuchoice(oldchoice:integer):integer;
const prompt:string[6]='==>   ';
      title='dmonstration de TURBO GRAPHIX TOOLBOX ';
      n=9;
      menuitems:array [0..9] of string[32]=
        ('Sortir de la dmonstration       ',
         'Utilisation des fentres         ',
         'Les commandes graphiques simples ',
         'Courbes de Sierpinski            ',
         'Camemberts                       ',
         'Lissage par Splines              ',
         'Prsentation de polygones        ',
         'Histogramme                      ',
         'Application: Un organigramme     ',
         'Dessins et conception            ');

var x,y,i,j:integer;
    ch:char;
    quit:boolean;
begin
  quit:=false;
  oldchoice:=oldchoice+1;
  if oldchoice>n-1 then oldchoice:=1;
  x:=40-length(title) div 2;
  gotoxy(x,1);
  write(title);
  gotoxy(8,24);
  write(' Selection par ESPACE / BACKSPACE ou un numro, puis tapez sur ENTER');
  y:=8-n div 2;
  x:=20;
  for i:=0 to n do
    begin
      gotoxy(x-4,y+i*2);
      write(i:1,' -- ',menuitems[i]);
    end;
  i:=oldchoice;
  gotoxy(x-10,y+i*2);
  write(prompt,i:1,' -- ',menuitems[i]);
  gotoxy(62,y+i*2);
  write('<==');
  j:=0;
  while ch<>^M do
    begin
      ch:='.';
      if keypressed then
        begin
          read(kbd,ch);
          j:=0;
        end;
      if ch=^H then
        begin
          gotoxy(x-10,y+i*2);
          write('      ');
          gotoxy(62,y+i*2);
          write('   ');
          i:=i-1;
          if i=-1 then i:=n;
          gotoxy(x-10,y+i*2);
          write(prompt,i:1,' -- ',menuitems[i]);
          gotoxy(62,y+i*2);
          write('<==');
        end;
      if ch=' ' then
        begin
          gotoxy(x-10,y+i*2);
          write('      ');
          gotoxy(62,y+i*2);
          write('   ');
          i:=i+1;
          if i>n then i:=0;
          gotoxy(x-10,y+i*2);
          write(prompt,i:1,' -- ',menuitems[i]);
          gotoxy(62,y+i*2);
          write('<==');
        end;
      if (ord(ch)-48 in [0..n]) and (ord(ch)-48<>i) then
        begin
          gotoxy(x-10,y+i*2);
          write('      ');
          gotoxy(62,y+i*2);
          write('   ');
          i:=ord(ch)-48;
          gotoxy(x-10,y+i*2);
          write(prompt,i:1,' -- ',menuitems[i]);
          gotoxy(62,y+i*2);
          write('<==');
        end;
      if ch=^C then quit:=true;
      if (ch=^[) then
        if keypressed then
         begin
          read(kbd,ch);
          if ch='O' then quit:=true;
         end
        else quit:=true;
      if quit then
       begin
        LeaveGraphic;
        halt;
       end;
      j:=j+1;
      if j=15000 then ch:=^M;
    end;
  menuchoice:=i;
end;

procedure dummy2;
begin
end;

overlay procedure SimpleInfo;
begin
  gotoxy(20,5);
  writeln('Les commandes de dessin simple');
  gotoxy(10,10);write('L''utilisateur peut raliser grce aux commandes de dessin simple');
  gotoxy(10,11);write('des reprsentations graphiques suivant sa propre image mentale. ');
  gotoxy(10,12);write('Ces commandes se rfreront  la fentre en cours.Il n''est ainsi ');
  gotoxy(10,13);write('normalement possible de dessiner qu'' l''intrieur de cette fentre. ');
  gotoxy(10,14);write('Si une partie du diagramme va au-del des limites de la');
  gotoxy(10,15);write('fentre,elle ne sera pas affiche.Pour fournir une plus');
  gotoxy(10,16);write('grande flexiblit d''emploi cette caractristique peut tre annule.');
  gotoxy(10,17);write('La mise  l''chelle d''un diagramme est aussi prise en charge');
  gotoxy(10,18);write('par TURBO GRAPHIX .Ainsi, il est possible de dessiner dans n''importe ');
  gotoxy(10,19);write('quel systme de coordonnes sans effectuer des calculs compliqus.');
  gotoxy(10,20);write('Un systme de coordonnes spar peut tre affect  chaque fentre.');
  gotoxy(10,21);write('dfinie');
  gotoxy(31,25);
  waitreturn(60000.0);
  simple;
end;

overlay procedure WindowDemoInfo;
begin
  gotoxy(20,5);
  writeln('L''utilisation des fentres');
  gotoxy(10,8);write('Avec le systme TURBO GRAPHIX,on peut afficher autant de fentres');
  gotoxy(10,9);write('que l''on dsire.Aprs dfinition les fentres slectionnes reprsen-');
  gotoxy(10,10);write('tent les feuilles de dessin relles.Toutes les oprations graphiques');
  gotoxy(10,11);write('qui peuvent tre normalement ralises sur l''cran peuvent tre faites ');
  gotoxy(10,12);write('dans une ou plusieurs fentres, exactement de la mme faon');
  gotoxy(10,13);write('Ainsi diffrentes oprations pourront tre affiches sur l''cran');
  gotoxy(10,14);write('d''une faon simple et claire.');
  gotoxy(10,16);write('Grce  ces commandes simples,les fentres peuvent tre dplaces sur');
  gotoxy(10,17);write('l''cran,et tre imprimes dans la position dsire. Chaque fentre');
  gotoxy(10,18);write('peut tre stocke dans une mmoire de fentre, qui est indpendante');
  gotoxy(10,19);write('de l''cran, et peut tre rapidement restaure n''importe ');
  gotoxy(10,20);write('o sur l''cran.La taille de la mmoire de fentre est limite ');
  gotoxy(10,21);write('par celle de la mmoire principale.');
  gotoxy(31,25);
  waitreturn(60000.0);
  WindowDemo;
end;

overlay procedure SplineInfo;
begin
  gotoxy(20,5);writeln('Utilisation des fonctions de Spline ');
  gotoxy(10,10);write('Procdure : spline(paramtre);');
  gotoxy(10,13);write('La procdure Spline permet de lisser des courbes.');
  gotoxy(10,14);write('Vous donnez un nombre de colonnes, dterminez ');
  gotoxy(10,15);write('celles de dbut et de fin de l''interpolation,');
  gotoxy(10,16);write('le nombre de points entre le dbut et la fin, ');
  gotoxy(10,17);write('vous appelez spline, puis dessinez les points avec ');
  gotoxy(10,18);write('l''aide de la procdure DrawPolygon .');
  gotoxy(10,19);write('Dans l''exemple suivant les donnes (*) seront prsentes ');
  gotoxy(10,20);write('en premier puis la fonction spline cree (50 points) sera');
  gotoxy(10,21);write('trace (ligne pleine) .');
  gotoxy(20,25);
  waitreturn(60000.0);
  SplineDem;
end;

overlay procedure PieInfo;
begin
  gotoxy(20,5);writeln('Utilisation des camemberts');
  gotoxy(10,8);write('Procdures : DrawCartPie ou DrawPolarPie(paramtre);');
  gotoxy(10,10);write('Elles permettent de crer des camemberts.');
  gotoxy(10,11);write('Pour crer un camembert, donnez les coordonnes du centre,');
  gotoxy(10,12);write('le nombre de segments dcals  dessiner,le nombre total de segments,');
  gotoxy(10,13);write('un champ numrique et un texte descriptif. Si vous le dsirez,le texte');
  gotoxy(10,14);write('et les chiffres seront affichs ensemble ou sparement.');
  gotoxy(10,15);write('L''exemple suivant liste les donnes de base du diagramme.');
  gotoxy(10,16);write('En mme temps,un camembert est dessin ,en arrire plan, sur');
  gotoxy(10,17);write('le second cran puis est copi sur le premier cran. ');
  gotoxy(10,18);write('Ensuite plusieurs variantes de la mme opration sont affiches.');
  gotoxy(20,25);
  waitreturn(60000.0);
  PieDem;
end;

overlay procedure BezierInfo;
begin
  gotoxy(10,5);writeln('Utilisation de la fonction BEZIER pour dessiner');
  gotoxy(3,8);write('Procdure : bezier(paramtre);');
  gotoxy(3,10);write('Elle permet de lisser des objets bidimensionnels  partir des');
  gotoxy(3,11);write('points donns par l''utilisateur. Elle peut tre aussi utilise');
  gotoxy(3,12);write('pour des courbes  large incurvation et des polynmes peu commodes.');
  gotoxy(3,13);write('L''exemple suivant dessinera 7 points (les carrs clairs) et la fonction');
  gotoxy(3,14);write('correspondante (ligne pleine). Vous pouvez changer la position des');
  gotoxy(3,15);write('points en entrant leur numro (1  7) et leurs nouvelles coordonnes');
  gotoxy(3,16);write('La procdure crera alors  les fonctions correspondantes.');
  gotoxy(3,17);write('Vous pouvez quitter ce module en tapant sur ENTER lors');
  gotoxy(3,18);write('de la demande du numro en question.');
  gotoxy(20,25);
  waitreturn(60000.0);
  BezierDem;
end;

overlay procedure PolygonInfo;
begin
  gotoxy(10,5);writeln('Possibilits de diagrammes polygonaux');
  gotoxy(3,8);write('Commande : DrawPolygon(paramtre);');
  gotoxy(3,10);write('Cette commande est utilise pour dessiner des polygones.Elle ');
  gotoxy(3,11);write('relie les sommets d''un polygone avec diffrents types de lignes, ');
  gotoxy(3,12);write('marque les coins avec diffrents symboles tel que toiles, carrs');
  gotoxy(3,13);write('etc.,cre des barres et plus encore.Au moyen de dessins rpets dans');
  gotoxy(3,14);write('la mme fentre,plusieurs polygones peuvent tre mis les uns sur les autres.');
  gotoxy(3,15);write('Tout diagramme peut tre dessin avec ou sans coordonnes ou texte.');
  gotoxy(3,16);write('Les exemples suivants ont t cres avec la procdure tout en faisant varier');
  gotoxy(3,17);write('le paramtre. Grce  la commande DrawAxis une prsentation des axes');
  gotoxy(3,18);write('incluant du texte est possible.Tapez sur ENTER pour vous dplacer ');
  gotoxy(3,19);write(' l''intrieur de ce module de dmonstration.');
  gotoxy(20,25);
  waitreturn(60000.0);
  PolygonDem;
end;

var choice:integer;

Begin
  InitGraphic;
  SetBreakOn;
  SetMessageOn;
  SetHeaderOn;
  DefineWorld(2,0,199,639,0);
  DefineWindow(10,0,0,XMaxGlb,YMaxGlb);
  intro;
  choice:=0;
  repeat
    ClearScreen;
    ResetWindowStack;
    ResetWindows;
    ResetWorlds;
    DefineWorld(2,0,199,639,0);
    DefineWindow(10,0,0,XMaxGlb,YMaxGlb);
    SelectWorld(2);
    SelectWindow(10);
    SetAspect(1.0);
    choice:=menuchoice(choice);
    ClearScreen;
    case choice of
      1:WindowDemoInfo;
      2:SimpleInfo;
      3:sier;
      4:PieInfo;
      5:SplineInfo;
      6:PolygonInfo;
      7:HistoDem;
      8:FlowChartDem;
      9:BezierInfo;
    end;
  until choice=0;
  LeaveGraphic;
end.





